'/* gbase64.h - Base64 coding functions
' *
' *  Copyright (C) 2005  Alexander Larsson <alexl@redhat.com>
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Library General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Library General Public License for more details.
' *
' * You should have received a copy of the GNU Library General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_BASE64_H__
'#define __G_BASE64_H__

#IF NOT %DEF(%GBASE64_INC)
    %GBASE64_INC = 1

#INCLUDE ONCE "gtypes.inc"

'G_BEGIN_DECLS

' ========================================================================================
'gsize   g_base64_encode_step  (const guchar *in,
'                               gsize         len,
'                               gboolean      break_lines,
'                               gchar        *out,
'                               gint         *state,
'                               gint         *save);
' ========================================================================================
DECLARE FUNCTION g_base64_encode_step CDECL LIB $GLIB_DLLNAME ALIAS "g_base64_encode_step" ( _
   BYREF ANY _                              ' const guchar *in
 , BYVAL DWORD _                            ' gsize         len
 , BYVAL LONG _                             ' gboolean      break_lines
 , BYREF ANY _                              ' gchar        *out
 , BYREF LONG _                             ' gint         *state
 , BYREF LONG _                             ' gint         *save
 ) AS DWORD                                 ' gsize

' ========================================================================================
'gsize   g_base64_encode_close (gboolean      break_lines,
'                               gchar        *out,
'                               gint         *state,
'                               gint         *save);
' ========================================================================================
DECLARE FUNCTION g_base64_encode_close CDECL LIB $GLIB_DLLNAME ALIAS "g_base64_encode_close" ( _
   BYVAL LONG _                             ' gboolean      break_lines
 , BYREF ANY _                              ' gchar        *out
 , BYREF LONG _                             ' gint         *state
 , BYREF LONG _                             ' gint         *save
 ) AS DWORD                                 ' gsize

' ========================================================================================
'gchar*  g_base64_encode       (const guchar *data,
'                               gsize         len) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_base64_encode CDECL LIB $GLIB_DLLNAME ALIAS "g_base64_encode" ( _
   BYREF ANY _                              ' const guchar *data
 , BYVAL DWORD _                            ' gsize         len
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gsize   g_base64_decode_step  (const gchar  *in,
'                               gsize         len,
'                               guchar       *out,
'                               gint         *state,
'                               guint        *save);
' ========================================================================================
DECLARE FUNCTION g_base64_decode_step CDECL LIB $GLIB_DLLNAME ALIAS "g_base64_decode_step" ( _
   BYREF ANY _                              ' const gchar  *in
 , BYVAL DWORD _                            ' gsize         len
 , BYREF ANY _                              ' guchar       *out
 , BYREF LONG _                             ' gint         *state
 , BYREF DWORD _                            ' guint        *save
 ) AS DWORD                                 ' gsize

' ========================================================================================
'guchar *g_base64_decode       (const gchar  *text,
'                               gsize        *out_len) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_base64_decode CDECL LIB $GLIB_DLLNAME ALIAS "g_base64_decode" ( _
   BYREF ASCIIZ _                           ' const gchar  *text
 , BYREF DWORD _                            ' gsize        *out_len
 ) AS DWORD                                 ' guchar*

'G_END_DECLS

'#endif /* __G_BASE64_H__ */
#ENDIF   ' /* __GBASE64_INC__ */
