'/* gbookmarkfile.h: parsing and building desktop bookmarks
' *
' * Copyright (C) 2005-2006 Emmanuele Bassi
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Library General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Library General Public License for more details.
' *
' * You should have received a copy of the GNU Library General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_BOOKMARK_FILE_H__
'#define __G_BOOKMARK_FILE_H__

#IF NOT %DEF(%GBOOKMARKFILE_INC)
    %GBOOKMARKFILE_INC = 1

#INCLUDE ONCE "gerror.inc"
#INCLUDE ONCE "time.inc"

'G_BEGIN_DECLS

'/* GError enumeration
' */
'#define G_BOOKMARK_FILE_ERROR   (g_bookmark_file_error_quark ())

'typedef enum
'{
'  G_BOOKMARK_FILE_ERROR_INVALID_URI,
'  G_BOOKMARK_FILE_ERROR_INVALID_VALUE,
'  G_BOOKMARK_FILE_ERROR_APP_NOT_REGISTERED,
'  G_BOOKMARK_FILE_ERROR_URI_NOT_FOUND,
'  G_BOOKMARK_FILE_ERROR_READ,
'  G_BOOKMARK_FILE_ERROR_UNKNOWN_ENCODING,
'  G_BOOKMARK_FILE_ERROR_WRITE,
'  G_BOOKMARK_FILE_ERROR_FILE_NOT_FOUND
'} GBookmarkFileError;

%G_BOOKMARK_FILE_ERROR_INVALID_URI        = 0
%G_BOOKMARK_FILE_ERROR_INVALID_VALUE      = 1
%G_BOOKMARK_FILE_ERROR_APP_NOT_REGISTERED = 2
%G_BOOKMARK_FILE_ERROR_URI_NOT_FOUND      = 3
%G_BOOKMARK_FILE_ERROR_READ               = 4
%G_BOOKMARK_FILE_ERROR_UNKNOWN_ENCODING   = 5
%G_BOOKMARK_FILE_ERROR_WRITE              = 6
%G_BOOKMARK_FILE_ERROR_FILE_NOT_FOUND     = 7

' ========================================================================================
'GQuark g_bookmark_file_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_error_quark" ( _
 ) AS DWORD                                 ' GQuark

DECLARE FUNCTION G_BOOKMARK_FILE_ERROR CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_error_quark" ( _
 ) AS DWORD                                 ' GQuark

'/*
' * GBookmarkFile
' */
'typedef struct _GBookmarkFile GBookmarkFile;

' ========================================================================================
'GBookmarkFile *g_bookmark_file_new                 (void);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_new CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_new" ( _
 ) AS DWORD                                 ' GBookmarkFile*

' ========================================================================================
'void           g_bookmark_file_free                (GBookmarkFile  *bookmark);
' ========================================================================================
DECLARE SUB g_bookmark_file_free CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_free" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 )                                          ' void

' ========================================================================================
'gboolean       g_bookmark_file_load_from_file      (GBookmarkFile  *bookmark,
'                                                    const gchar    *filename,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_load_from_file CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_load_from_file" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *filename
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean*

' ========================================================================================
'gboolean       g_bookmark_file_load_from_data      (GBookmarkFile  *bookmark,
'                                                    const gchar    *data,
'                                                    gsize           length,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_load_from_data CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_load_from_data" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ANY _                              ' const gchar    *data
 , BYVAL DWORD _                            ' gsize           length
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean*

' ========================================================================================
'gboolean       g_bookmark_file_load_from_data_dirs (GBookmarkFile  *bookmark,
'                                                    const gchar    *file,
'                                                    gchar         **full_path,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_load_from_data_dirs CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_load_from_data_dirs" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *file
 , BYREF DWORD _                            ' gchar         **full_path
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean*

' ========================================================================================
'gchar *        g_bookmark_file_to_data             (GBookmarkFile  *bookmark,
'                                                    gsize          *length,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_to_data CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_to_data" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF DWORD _                            ' gsize          *length
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gboolean       g_bookmark_file_to_file             (GBookmarkFile  *bookmark,
'                                                    const gchar    *filename,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_to_file CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_to_file" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *filename
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean*

' ========================================================================================
'void           g_bookmark_file_set_title           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *title);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_title CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_title" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *title
 )                                          ' void

' ========================================================================================
'gchar *        g_bookmark_file_get_title           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_title CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_title" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void           g_bookmark_file_set_description     (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *description);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_description CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_description" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *description
 )                                          ' void

' ========================================================================================
'gchar *        g_bookmark_file_get_description     (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_description CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_description" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void           g_bookmark_file_set_mime_type       (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *mime_type);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_mime_type CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_mime_type" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *mime_type
 )                                          ' void

' ========================================================================================
'gchar *        g_bookmark_file_get_mime_type       (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_mime_type CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_mime_type" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void           g_bookmark_file_set_groups          (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar   **groups,
'                                                    gsize           length);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_groups CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_groups" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar   **groups
 , BYVAL DWORD _                            ' gsize           length
 )                                          ' void

' ========================================================================================
'void           g_bookmark_file_add_group           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *group);
' ========================================================================================
DECLARE SUB g_bookmark_file_add_group CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_add_group" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *group
 )                                          ' void

' ========================================================================================
'gboolean       g_bookmark_file_has_group           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *group,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_has_group CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_has_group" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *group
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar **       g_bookmark_file_get_groups          (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    gsize          *length,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_groups CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_groups" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYVAL DWORD _                            ' gsize          *length
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'void           g_bookmark_file_add_application     (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *name,
'                                                    const gchar    *exec);
' ========================================================================================
DECLARE SUB g_bookmark_file_add_application CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_add_application" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *name
 , BYREF ASCIIZ _                           ' const gchar    *exec
 )                                          ' void

' ========================================================================================
'gboolean       g_bookmark_file_has_application     (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *name,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_has_application CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_has_application" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *name
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar **       g_bookmark_file_get_applications    (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    gsize          *length,
'                                                    GError        **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_applications CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_applications" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' gsize          *length
 , BYREF DWORD _                            ' GError        **error
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gboolean       g_bookmark_file_set_app_info        (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *name,
'                                                    const gchar    *exec,
'                                                    gint            count,
'                                                    time_t          stamp,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_set_app_info CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_app_info" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *name
 , BYREF ASCIIZ _                           ' const gchar    *exec
 , BYVAL LONG _                             ' gint            count
 , BYVAL LONG _                             ' time_t          stamp
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean       g_bookmark_file_get_app_info        (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *name,
'                                                    gchar         **exec,
'                                                    guint          *count,
'                                                    time_t         *stamp,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_app_info CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_app_info" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *name
 , BYREF DWORD _                            ' const gchar   **exec
 , BYVAL LONG _                             ' gint            count
 , BYVAL LONG _                             ' time_t          stamp
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void           g_bookmark_file_set_is_private      (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    gboolean        is_private);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_is_private CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_is_private" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYVAL LONG _                             ' gboolean        is_private
 )                                          ' void

' ========================================================================================
'gboolean       g_bookmark_file_get_is_private      (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_is_private CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_is_private" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void           g_bookmark_file_set_icon            (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *href,
'                                                    const gchar    *mime_type);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_icon CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_icon" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *href
 , BYREF ASCIIZ _                           ' const gchar    *mime_type
 )                                          ' void

' ========================================================================================
'gboolean       g_bookmark_file_get_icon            (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    gchar         **href,
'                                                    gchar         **mime_type,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_icon CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_icon" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' gchar         **href
 , BYREF DWORD _                            ' gchar         **mime_type
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void           g_bookmark_file_set_added           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    time_t          added);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_added CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_added" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYVAL LONG _                             ' time_t          added
 )                                          ' void

' ========================================================================================
'time_t         g_bookmark_file_get_added           (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_added CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_added" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' time_t

' ========================================================================================
'void           g_bookmark_file_set_modified        (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    time_t          modified);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_modified CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_modified" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYVAL LONG _                             ' time_t          modified
 )                                          ' void

' ========================================================================================
'time_t         g_bookmark_file_get_modified        (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_modified CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_modified" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' time_t

' ========================================================================================
'void           g_bookmark_file_set_visited         (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    time_t          visited);
' ========================================================================================
DECLARE SUB g_bookmark_file_set_visited CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_set_visited" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYVAL LONG _                             ' time_t          visited
 )                                          ' void

' ========================================================================================
'time_t         g_bookmark_file_get_visited         (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_visited CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_visited" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' time_t

' ========================================================================================
'gboolean       g_bookmark_file_has_item            (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_has_item CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_has_item" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gint           g_bookmark_file_get_size            (GBookmarkFile  *bookmark);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_size CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_size" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 ) AS LONG                                  ' gint

' ========================================================================================
'gchar **       g_bookmark_file_get_uris            (GBookmarkFile  *bookmark,
'                                                    gsize          *length) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_get_uris CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_get_uris" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF DWORD _                            ' gsize          *length
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gboolean       g_bookmark_file_remove_group        (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *group,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_remove_group CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_remove_group" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *group
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean       g_bookmark_file_remove_application  (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    const gchar    *name,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_remove_application CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_remove_application" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF ASCIIZ _                           ' const gchar    *name
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean       g_bookmark_file_remove_item         (GBookmarkFile  *bookmark,
'                                                    const gchar    *uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_remove_item CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_remove_item" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean       g_bookmark_file_move_item           (GBookmarkFile  *bookmark,
'                                                    const gchar    *old_uri,
'                                                    const gchar    *new_uri,
'                                                    GError        **error);
' ========================================================================================
DECLARE FUNCTION g_bookmark_file_move_item CDECL LIB $GLIB_DLLNAME ALIAS "g_bookmark_file_move_item" ( _
   BYVAL DWORD _                            ' GBookmarkFile  *bookmark
 , BYREF ASCIIZ _                           ' const gchar    *old_uri
 , BYREF ASCIIZ _                           ' const gchar    *new_uri
 , BYREF DWORD _                            ' GError        **error
 ) AS LONG                                  ' gboolean

'G_END_DECLS

'#endif /* __G_BOOKMARK_FILE_H__ */
#ENDIF   ' /* __GBOOKMARKFILE_INC__ */
