'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_CONVERT_H__
'#define __G_CONVERT_H__

#IF NOT %DEF(%GCONVERT_INC)
    %GCONVERT_INC = 1

#INCLUDE ONCE "gerror.inc"

'G_BEGIN_DECLS

'typedef enum
'{
'  G_CONVERT_ERROR_NO_CONVERSION,
'  G_CONVERT_ERROR_ILLEGAL_SEQUENCE,
'  G_CONVERT_ERROR_FAILED,
'  G_CONVERT_ERROR_PARTIAL_INPUT,
'  G_CONVERT_ERROR_BAD_URI,
'  G_CONVERT_ERROR_NOT_ABSOLUTE_PATH
'} GConvertError;

%G_CONVERT_ERROR_NO_CONVERSION     = 0
%G_CONVERT_ERROR_ILLEGAL_SEQUENCE  = 1
%G_CONVERT_ERROR_FAILED            = 2
%G_CONVERT_ERROR_PARTIAL_INPUT     = 3
%G_CONVERT_ERROR_BAD_URI           = 4
%G_CONVERT_ERROR_NOT_ABSOLUTE_PATH = 5

' ========================================================================================
'#define G_CONVERT_ERROR g_convert_error_quark()
'GQuark g_convert_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_convert_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_convert_error_quark" ( _
 ) AS DWORD                                 ' GQuark

DECLARE FUNCTION G_CONVERT_ERROR CDECL LIB $GLIB_DLLNAME ALIAS "g_convert_error_quark" ( _
 ) AS DWORD                                 ' GQuark

'/* Thin wrappers around iconv
' */
'typedef struct _GIConv *GIConv;

' ========================================================================================
'GIConv g_iconv_open   (const gchar  *to_codeset,
'                       const gchar  *from_codeset);
' ========================================================================================
DECLARE FUNCTION g_iconv_open CDECL LIB $GLIB_DLLNAME ALIAS "g_iconv_open" ( _
   BYREF ASCIIZ _                           ' const gchar  *to_codeset
 , BYREF ASCIIZ _                           ' const gchar  *from_codeset
 ) AS DWORD                                 ' GIConv

' ========================================================================================
'gsize  g_iconv        (GIConv        converter,
'                       gchar       **inbuf,
'                       gsize        *inbytes_left,
'                       gchar       **outbuf,
'                       gsize        *outbytes_left);
' ========================================================================================
DECLARE FUNCTION g_iconv CDECL LIB $GLIB_DLLNAME ALIAS "g_iconv" ( _
   BYVAL DWORD _                            ' GIConv        converter
 , BYREF ASCIIZ _                           ' gchar       **inbuf
 , BYREF DWORD _                            ' gsize        *inbytes_left
 , BYREF ASCIIZ _                           ' gchar       **outbuf
 , BYREF DWORD _                            ' gsize        *outbytes_left
 ) AS DWORD                                 ' gsize

' ========================================================================================
'gint   g_iconv_close  (GIConv        converter);
' ========================================================================================
DECLARE FUNCTION g_iconv_close CDECL LIB $GLIB_DLLNAME ALIAS "g_iconv_close" ( _
   BYVAL DWORD _                            ' GIConv        converter
 ) AS LONG                                  ' gint

' ========================================================================================
'gchar* g_convert               (const gchar  *str,
'                                gssize        len,
'                                const gchar  *to_codeset,
'                                const gchar  *from_codeset,
'                                gsize        *bytes_read,
'                                gsize        *bytes_written,
'                                GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_convert CDECL LIB $GLIB_DLLNAME ALIAS "g_convert" ( _
   BYREF ASCIIZ _                           ' const gchar  *str
 , BYVAL LONG _                             ' gssize        len
 , BYREF ASCIIZ _                           ' const gchar  *to_codeset
 , BYREF ASCIIZ _                           ' const gchar  *from_codeset
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar* g_convert_with_iconv    (const gchar  *str,
'                                gssize        len,
'                                GIConv        converter,
'                                gsize        *bytes_read,
'                                gsize        *bytes_written,
'                                GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_convert_with_iconv CDECL LIB $GLIB_DLLNAME ALIAS "g_convert_with_iconv" ( _
   BYREF ASCIIZ _                           ' const gchar  *str
 , BYVAL LONG _                             ' gssize        len
 , BYVAL DWORD _                            ' GIConv        converter
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar* g_convert_with_fallback (const gchar  *str,
'                                gssize        len,
'                                const gchar  *to_codeset,
'                                const gchar  *from_codeset,
'                                gchar        *fallback,
'                                gsize        *bytes_read,
'                                gsize        *bytes_written,
'                                GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_convert_with_fallback CDECL LIB $GLIB_DLLNAME ALIAS "g_convert_with_fallback" ( _
   BYREF ASCIIZ _                           ' const gchar  *str
 , BYVAL LONG _                             ' gssize        len
 , BYREF ASCIIZ _                           ' const gchar  *to_codeset
 , BYREF ASCIIZ _                           ' const gchar  *from_codeset
 , BYREF ASCIIZ _                           ' const gchar  *fallback
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

'/* Convert between libc's idea of strings and UTF-8.
' */

' ========================================================================================
'gchar* g_locale_to_utf8   (const gchar  *opsysstring,
'                           gssize        len,
'                           gsize        *bytes_read,
'                           gsize        *bytes_written,
'                           GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_locale_to_utf8 CDECL LIB $GLIB_DLLNAME ALIAS "g_locale_to_utf8" ( _
   BYREF ASCIIZ _                           ' const gchar  *opsysstring
 , BYVAL LONG _                             ' gssize        len
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar* g_locale_from_utf8 (const gchar  *utf8string,
'                           gssize        len,
'                           gsize        *bytes_read,
'                           gsize        *bytes_written,
'                           GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_locale_from_utf8 CDECL LIB $GLIB_DLLNAME ALIAS "g_locale_from_utf8" ( _
   BYREF ASCIIZ _                           ' const gchar  *utf8string
 , BYVAL LONG _                             ' gssize        len
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

'/* Convert between the operating system (or C runtime)
' * representation of file names and UTF-8.
' */

'#ifdef G_OS_WIN32
'#define g_filename_to_utf8 g_filename_to_utf8_utf8
'#define g_filename_from_utf8 g_filename_from_utf8_utf8
'#define g_filename_from_uri g_filename_from_uri_utf8
'#define g_filename_to_uri g_filename_to_uri_utf8
'#endif

' ========================================================================================
'gchar* g_filename_to_utf8   (const gchar  *opsysstring,
'                             gssize        len,
'                             gsize        *bytes_read,
'                             gsize        *bytes_written,
'                             GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_to_utf8 CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_to_utf8" ( _
   BYREF ASCIIZ _                           ' const gchar  *opsysstring
 , BYVAL LONG _                             ' gssize        len
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar* g_filename_from_utf8 (const gchar  *utf8string,
'                             gssize        len,
'                             gsize        *bytes_read,
'                             gsize        *bytes_written,
'                             GError      **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_from_utf8 CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_from_utf8" ( _
   BYREF ASCIIZ _                           ' const gchar  *utf8string
 , BYVAL LONG _                             ' gssize        len
 , BYREF DWORD _                            ' gsize        *bytes_read
 , BYREF DWORD _                            ' gsize        *bytes_written
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *g_filename_from_uri (const gchar *uri,
'                            gchar      **hostname,
'                            GError     **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_from_uri CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_from_uri" ( _
   BYREF ASCIIZ _                           ' const gchar  *uri
 , BYREF ASCIIZ _                           ' gchar      **hostname
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *g_filename_to_uri   (const gchar *filename,
'                            const gchar *hostname,
'                            GError     **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_to_uri CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_to_uri" ( _
   BYREF ASCIIZ _                           ' const gchar  *filename
 , BYREF ASCIIZ _                           ' const gchar  *hostname
 , BYREF DWORD _                            ' GError      **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *g_filename_display_name (const gchar *filename) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_display_name CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_display_name" ( _
   BYREF ASCIIZ _                           ' const gchar  *filename
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gboolean g_get_filename_charsets (G_CONST_RETURN gchar ***charsets);
' Usage:
' DIM bRes AS LONG
' DIM psz AS ASCIIZ PTR
' DIM strCharsets AS STRING
' bRes = g_get_filename_charsets(psz)
' IF psz THEN strCharsets = @@psz
' ========================================================================================
DECLARE FUNCTION g_get_filename_charsets CDECL LIB $GLIB_DLLNAME ALIAS "g_get_filename_charsets" ( _
   BYREF DWORD _                            ' G_CONST_RETURN gchar ***charsets
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar *g_filename_display_basename (const gchar *filename) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_filename_display_basename CDECL LIB $GLIB_DLLNAME ALIAS "g_filename_display_basename" ( _
   BYREF ASCIIZ _                           ' const gchar *filename
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar **g_uri_list_extract_uris (const gchar *uri_list) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_uri_list_extract_uris CDECL LIB $GLIB_DLLNAME ALIAS "g_uri_list_extract_uris" ( _
   BYREF ASCIIZ _                           ' const gchar *uri_list
 ) AS DWORD                                 ' gchar**

'G_END_DECLS

'#endif /* __G_CONVERT_H__ */
#ENDIF   ' /* __GCONVERT_INC__ */
