'/* gerror.h - Error reporting system
' *
' *  Copyright 2000 Red Hat, Inc.
' *
' * The Gnome Library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public License as
' * published by the Free Software Foundation; either version 2 of the
' * License, or (at your option) any later version.
' *
' * The Gnome Library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with the Gnome Library; see the file COPYING.LIB.  If not,
' * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' *   Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_ERROR_H__
'#define __G_ERROR_H__

#IF NOT %DEF(%GERROR_INC)
    %GERROR_INC = 1

#INCLUDE ONCE "gquark.inc"

'G_BEGIN_DECLS

'typedef struct _GError GError;

'struct _GError
'{
'  GQuark       domain;
'  gint         code;
'  gchar       *message;
'};

TYPE GError
   domain  AS DWORD
   code    AS LONG
   message AS ASCIIZ PTR
END TYPE


' ========================================================================================
'GError*  g_error_new           (GQuark         domain,
'                                gint           code,
'                                const gchar   *format,
'                                ...) G_GNUC_PRINTF (3, 4);
' ========================================================================================
DECLARE FUNCTION g_error_new CDECL LIB $GLIB_DLLNAME ALIAS "g_error_new" ( _
   BYVAL DWORD _                            ' GQuark         domain
 , BYVAL LONG _                             ' gint           code
 , BYREF ASCIIZ _                           ' const gchar   *format
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS DWORD                                 ' GError*

' ========================================================================================
'GError*  g_error_new_literal   (GQuark         domain,
'                                gint           code,
'                                const gchar   *message);
' ========================================================================================
DECLARE FUNCTION g_error_new_literal CDECL LIB $GLIB_DLLNAME ALIAS "g_error_new_literal" ( _
   BYVAL DWORD _                            ' GQuark         domain
 , BYVAL LONG _                             ' gint           code
 , BYREF ASCIIZ _                           ' const gchar   *message
 ) AS DWORD                                 ' GError*

' ========================================================================================
'void     g_error_free          (GError        *error);
' ========================================================================================
DECLARE SUB g_error_free CDECL LIB $GLIB_DLLNAME ALIAS "g_error_free" ( _
   BYVAL GError PTR _                       ' GError        *error
 )                                          ' void

' ========================================================================================
'GError*  g_error_copy          (const GError  *error);
' ========================================================================================
DECLARE FUNCTION g_error_copy CDECL LIB $GLIB_DLLNAME ALIAS "g_error_copy" ( _
   BYVAL GError PTR _                       ' const GError  *error
 ) AS DWORD                                 ' GError*

' ========================================================================================
'gboolean g_error_matches       (const GError  *error,
'                                GQuark         domain,
'                                gint           code);
' ========================================================================================
DECLARE FUNCTION g_error_matches CDECL LIB $GLIB_DLLNAME ALIAS "g_error_matches" ( _
   BYVAL GError PTR _                       ' const GError  *error
 , BYVAL DWORD _                            ' GQuark         domain
 , BYVAL LONG _                             ' gint           code
 ) AS DWORD                                 ' GError*

'/* if (err) *err = g_error_new(domain, code, format, ...), also has
' * some sanity checks.
' */

' ========================================================================================
'void     g_set_error           (GError       **err,
'                                GQuark         domain,
'                                gint           code,
'                                const gchar   *format,
'                                ...) G_GNUC_PRINTF (4, 5);
' ========================================================================================
DECLARE SUB g_set_error CDECL LIB $GLIB_DLLNAME ALIAS "g_set_error" ( _
   BYREF DWORD _                            ' GError       **err
 , BYVAL DWORD _                            ' GQuark         domain
 , BYVAL LONG _                             ' gint           code
 , BYREF ASCIIZ _                           ' const gchar   *format
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 )                                          ' void

' ========================================================================================
'void     g_set_error_literal   (GError       **err,
'                                GQuark         domain,
'                                gint           code,
'                                const gchar   *message);
' ========================================================================================
DECLARE SUB g_set_error_literal CDECL LIB $GLIB_DLLNAME ALIAS "g_set_error_literal" ( _
   BYREF DWORD _                            ' GError       **err
 , BYVAL DWORD _                            ' GQuark         domain
 , BYVAL LONG _                             ' gint           code
 , BYREF ASCIIZ _                           ' const gchar   *message
 )                                          ' void

'/* if (dest) *dest = src; also has some sanity checks.
' */

' ========================================================================================
'void     g_propagate_error     (GError       **dest,
'                                GError        *src);
' ========================================================================================
DECLARE SUB g_propagate_error CDECL LIB $GLIB_DLLNAME ALIAS "g_propagate_error" ( _
   BYREF DWORD _                            ' GError       **dest
 , BYVAL GError PTR _                       ' GError        *src
 )                                          ' void

'/* if (err && *err) { g_error_free(*err); *err = NULL; } */

' ========================================================================================
'void     g_clear_error         (GError       **err);
' ========================================================================================
DECLARE SUB g_clear_error CDECL LIB $GLIB_DLLNAME ALIAS "g_clear_error" ( _
   BYREF DWORD _                            ' GError       **dest
 )                                          ' void

'/* if (err) prefix the formatted string to the ->message */

' ========================================================================================
'void     g_prefix_error               (GError       **err,
'                                       const gchar   *format,
'                                       ...) G_GNUC_PRINTF (2, 3);
' ========================================================================================
DECLARE SUB g_prefix_error CDECL LIB $GLIB_DLLNAME ALIAS "g_prefix_error" ( _
   BYREF DWORD _                            ' GError       **err
 , BYREF ASCIIZ _                           ' const gchar   *format
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 )                                          ' void

'/* g_propagate_error then g_error_prefix on dest */

' ========================================================================================
'void     g_propagate_prefixed_error   (GError       **dest,
'                                       GError        *src,
'                                       const gchar   *format,
'                                       ...) G_GNUC_PRINTF (3, 4);
' ========================================================================================
DECLARE SUB g_propagate_prefixed_error CDECL LIB $GLIB_DLLNAME ALIAS "g_propagate_prefixed_error" ( _
   BYREF DWORD _                            ' GError       **dest
 , BYVAL GError PTR _                       ' GError        *src
 , BYREF ASCIIZ _                           ' const gchar   *format
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 )                                          ' void

'G_END_DECLS

'#endif /* __G_ERROR_H__ */
#ENDIF   ' /* __GERROR_INC__ */
