'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_HASH_H__
'#define __G_HASH_H__

#IF NOT %DEF(%GHASH_INC)
    %GHASH_INC = 1

#INCLUDE ONCE "gtypes.inc"
#INCLUDE ONCE "glist.inc"

'G_BEGIN_DECLS

'typedef struct _GHashTable  GHashTable;

'typedef gboolean  (*GHRFunc)  (gpointer  key,
'                               gpointer  value,
'                               gpointer  user_data);

'FUNCTION GHRFunc (BYVAL pkey AS DWORD, BYVAL value AS DWORD, BYVAL user_data AS DWORD) AS LONG

'typedef struct _GHashTableIter GHashTableIter;

'struct _GHashTableIter
'{
'  /*< private >*/
'  gpointer   dummy1;
'  gpointer   dummy2;
'  gpointer   dummy3;
'  int        dummy4;
'  gboolean   dummy5;
'  gpointer   dummy6;
'};

TYPE GHashTableIter
   dummy1 AS DWORD
   dummy2 AS DWORD
   dummy3 AS DWORD
   dummy4 AS LONG
   dummy5 AS LONG
   dummy6 AS DWORD
END TYPE

'/* Hash tables
' */
' ========================================================================================
'GHashTable* g_hash_table_new (GHashFunc       hash_func,
'                              GEqualFunc      key_equal_func);
' ========================================================================================
DECLARE FUNCTION g_hash_table_new CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_new" ( _
   BYVAL DWORD _                            ' GHashFunc       hash_func
 , BYVAL DWORD _                            ' GEqualFunc      key_equal_func
 ) AS DWORD                                 ' GHashTable*

' ========================================================================================
'GHashTable* g_hash_table_new_full (GHashFunc       hash_func,
'                                   GEqualFunc      key_equal_func,
'                                   GDestroyNotify  key_destroy_func,
'                                   GDestroyNotify  value_destroy_func);
' ========================================================================================
DECLARE FUNCTION g_hash_table_new_full CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_new_full" ( _
   BYVAL DWORD _                            ' GHashFunc       hash_func
 , BYVAL DWORD _                            ' GEqualFunc      key_equal_func
 , BYVAL DWORD _                            ' GDestroyNotify  key_destroy_func
 , BYVAL DWORD _                            ' GDestroyNotify  value_destroy_func
 ) AS DWORD                                 ' GHashTable*

' ========================================================================================
'void       g_hash_table_destroy      (GHashTable      *hash_table);
' ========================================================================================
DECLARE SUB g_hash_table_destroy CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_destroy" ( _
   BYVAL DWORD _                            ' GHashTable     *hash_table
 )                                          ' void

' ========================================================================================
'void       g_hash_table_insert (GHashTable    *hash_table,
'                                gpointer       key,
'                                gpointer       value);
' ========================================================================================
DECLARE SUB g_hash_table_insert CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_insert" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gpointer       key
 , BYVAL DWORD _                            ' gpointer       value
 )                                          ' void

' ========================================================================================
'void        g_hash_table_replace (GHashTable    *hash_table,
'                                  gpointer       key,
'                                  gpointer       value);
' ========================================================================================
DECLARE SUB g_hash_table_replace CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_replace" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gpointer       key
 , BYVAL DWORD _                            ' gpointer       value
 )                                          ' void

' ========================================================================================
'gboolean    g_hash_table_remove (GHashTable     *hash_table,
'                                 gconstpointer   key);
' ========================================================================================
DECLARE FUNCTION g_hash_table_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_remove" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gconstpointer  key
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void        g_hash_table_remove_all        (GHashTable     *hash_table);
' ========================================================================================
DECLARE SUB g_hash_table_remove_all CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_remove_all" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 )                                          ' void

' ========================================================================================
'gboolean    g_hash_table_steal             (GHashTable     *hash_table,
'                                            gconstpointer   key);
' ========================================================================================
DECLARE FUNCTION g_hash_table_steal CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_steal" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gconstpointer  key
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void        g_hash_table_steal_all         (GHashTable     *hash_table);
' ========================================================================================
DECLARE SUB g_hash_table_steal_all CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_steal_all" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 )                                          ' void

' ========================================================================================
'gpointer    g_hash_table_lookup         (GHashTable     *hash_table,
'                                         gconstpointer   key);
' ========================================================================================
DECLARE FUNCTION g_hash_table_lookup CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_lookup" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gconstpointer  key
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gboolean    g_hash_table_lookup_extended   (GHashTable     *hash_table,
'                                            gconstpointer   lookup_key,
'                                            gpointer       *orig_key,
'                                            gpointer       *value);
' ========================================================================================
DECLARE FUNCTION g_hash_table_lookup_extended CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_lookup_extended" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' gconstpointer  lookup_key
 , BYREF DWORD _                            ' gpointer       *orig_key
 , BYREF DWORD _                            ' gpointer       *value
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void       g_hash_table_foreach      (GHashTable      *hash_table,
'                                      GHFunc           func,
'                                      gpointer         user_data);
' ========================================================================================
DECLARE SUB g_hash_table_foreach CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_foreach" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' GHFunc           func
 , BYVAL DWORD _                            ' gpointer         user_data
 )                                          ' void

' ========================================================================================
'gpointer    g_hash_table_find              (GHashTable      *hash_table,
'                                            GHRFunc          predicate,
'                                            gpointer         user_data);
' ========================================================================================
DECLARE FUNCTION g_hash_table_find CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_find" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' GHRFunc        predicate
 , BYVAL DWORD _                            ' gpointer       user_data
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'guint       g_hash_table_foreach_remove      (GHashTable      *hash_table,
'                                              GHRFunc          func,
'                                              gpointer         user_data);
' ========================================================================================
DECLARE FUNCTION g_hash_table_find CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_find" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' GHRFunc        func
 , BYVAL DWORD _                            ' gpointer       user_data
 ) AS DWORD                                 ' guint

' ========================================================================================
'guint       g_hash_table_foreach_steal      (GHashTable      *hash_table,
'                                             GHRFunc          func,
'                                             gpointer         user_data);
' ========================================================================================
DECLARE FUNCTION g_hash_table_foreach_steal CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_foreach_steal" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 , BYVAL DWORD _                            ' GHRFunc        func
 , BYVAL DWORD _                            ' gpointer       user_data
 ) AS DWORD                                 ' guint

' ========================================================================================
'guint       g_hash_table_size         (GHashTable      *hash_table);
' ========================================================================================
DECLARE FUNCTION g_hash_table_size CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_size" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 ) AS DWORD                                 ' guint

' ========================================================================================
'GList *     g_hash_table_get_keys          (GHashTable     *hash_table);
' ========================================================================================
DECLARE FUNCTION g_hash_table_get_keys CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_get_keys" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList *     g_hash_table_get_values        (GHashTable     *hash_table);
' ========================================================================================
DECLARE FUNCTION g_hash_table_get_values CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_get_values" ( _
   BYVAL DWORD _                            ' GHashTable    *hash_table
 ) AS DWORD                                 ' GList*

' ========================================================================================
'void        g_hash_table_iter_init         (GHashTableIter *iter,
'                                            GHashTable     *hash_table);
' ========================================================================================
DECLARE SUB g_hash_table_iter_init CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_iter_init" ( _
   BYVAL GHashTableIter PTR _               ' GHashTableIter *iter
 , BYVAL DWORD _                            ' GHashTable     *hash_table
 )                                          ' void

' ========================================================================================
'gboolean    g_hash_table_iter_next         (GHashTableIter *iter,
'                                            gpointer       *key,
'                                            gpointer       *value);
' ========================================================================================
DECLARE FUNCTION g_hash_table_iter_next CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_iter_next" ( _
   BYVAL GHashTableIter PTR _               ' GHashTableIter *iter
 , BYVAL DWORD _                            ' gpointer       *key
 , BYVAL DWORD _                            ' gpointer       *value
 ) AS LONG                                  ' gboolean

' ========================================================================================
'GHashTable* g_hash_table_iter_get_hash_table (GHashTableIter *iter);
' ========================================================================================
DECLARE FUNCTION g_hash_table_iter_get_hash_table CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_iter_get_hash_table" ( _
   BYVAL GHashTableIter PTR _               ' GHashTableIter *iter
 ) AS DWORD                                 ' GHashTable*

' ========================================================================================
'void        g_hash_table_iter_remove       (GHashTableIter *iter);
' ========================================================================================
DECLARE SUB g_hash_table_iter_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_iter_remove" ( _
   BYVAL GHashTableIter PTR _               ' GHashTableIter *iter
 )                                          ' void

' ========================================================================================
'void        g_hash_table_iter_steal        (GHashTableIter *iter);
' ========================================================================================
DECLARE SUB g_hash_table_iter_steal CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_iter_steal" ( _
   BYVAL GHashTableIter PTR _               ' GHashTableIter *iter
 )                                          ' void

'/* keeping hash tables alive */

' ========================================================================================
'GHashTable* g_hash_table_ref            (GHashTable       *hash_table);
' ========================================================================================
DECLARE FUNCTION g_hash_table_ref CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_ref" ( _
   BYVAL DWORD _                            ' GHashTable       *hash_table
 ) AS DWORD                                 ' GHashTable*

' ========================================================================================
'void        g_hash_table_unref             (GHashTable     *hash_table);
' ========================================================================================
DECLARE SUB g_hash_table_unref CDECL LIB $GLIB_DLLNAME ALIAS "g_hash_table_unref" ( _
   BYVAL DWORD _                            ' GHashTable     *hash_table
 )                                          ' void

'#ifndef G_DISABLE_DEPRECATED

'/* The following two functions are deprecated and will be removed in
' * the next major release. They do no good. */
'#define g_hash_table_freeze(hash_table) ((void)0)
'#define g_hash_table_thaw(hash_table) ((void)0)

'#endif /* G_DISABLE_DEPRECATED */

'/* Hash Functions
' */

' ========================================================================================
'gboolean g_str_equal (gconstpointer  v1,
'                      gconstpointer  v2);
' ========================================================================================
DECLARE FUNCTION g_str_equal CDECL LIB $GLIB_DLLNAME ALIAS "g_str_equal" ( _
   BYVAL DWORD _                            ' gconstpointer  v1
 , BYVAL DWORD _                            ' gconstpointer  v2
 ) AS LONG                                  ' gboolean

' ========================================================================================
'guint    g_str_hash  (gconstpointer  v);
' ========================================================================================
DECLARE FUNCTION g_str_hash CDECL LIB $GLIB_DLLNAME ALIAS "g_str_hash" ( _
   BYVAL DWORD _                            ' gconstpointer  v
 ) AS DWORD                                 ' guint

' ========================================================================================
'gboolean g_int_equal (gconstpointer  v1,
'                      gconstpointer  v2);
' ========================================================================================
DECLARE FUNCTION g_int_equal CDECL LIB $GLIB_DLLNAME ALIAS "g_int_equal" ( _
   BYVAL DWORD _                            ' gconstpointer  v1
 , BYVAL DWORD _                            ' gconstpointer  v2
 ) AS LONG                                  ' gboolean

' ========================================================================================
'guint    g_int_hash  (gconstpointer  v);
' ========================================================================================
DECLARE FUNCTION g_int_hash CDECL LIB $GLIB_DLLNAME ALIAS "g_int_hash" ( _
   BYVAL DWORD _                            ' gconstpointer  v
 ) AS DWORD                                 ' guint

'/* This "hash" function will just return the key's address as an
' * unsigned integer. Useful for hashing on plain addresses or
' * simple integer values.
' * Passing NULL into g_hash_table_new() as GHashFunc has the
' * same effect as passing g_direct_hash().
' */

' ========================================================================================
'guint    g_direct_hash  (gconstpointer  v) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_direct_hash CDECL LIB $GLIB_DLLNAME ALIAS "g_direct_hash" ( _
   BYVAL DWORD _                            ' gconstpointer  v
 ) AS DWORD                                 ' guint

' ========================================================================================
'gboolean g_direct_equal (gconstpointer  v1,
'                         gconstpointer  v2) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_direct_equal CDECL LIB $GLIB_DLLNAME ALIAS "g_direct_equal" ( _
   BYVAL DWORD _                            ' gconstpointer  v1
 , BYVAL DWORD _                            ' gconstpointer  v2
 ) AS LONG                                  ' gboolean

'G_END_DECLS

'#endif /* __G_HASH_H__ */
#ENDIF   ' /* __GHASH_INC__ */
