'/* gkeyfile.h - desktop entry file parser
' *
' *  Copyright 2004 Red Hat, Inc.
' *
' *  Ray Strode <halfline@hawaii.rr.com>
' *
' * GLib is free software; you can redistribute it and/or modify it
' * under the terms of the GNU Lesser General Public License as
' * published by the Free Software Foundation; either version 2 of the
' * License, or (at your option) any later version.
' *
' * GLib is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with GLib; see the file COPYING.LIB.  If not,
' * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' *   Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_KEY_FILE_H__
'#define __G_KEY_FILE_H__

#IF NOT %DEF(%GKEYFILE_INC)
    %GKEYFILE_INC = 1

#INCLUDE ONCE "gerror.inc"

'G_BEGIN_DECLS

'typedef enum
'{
'  G_KEY_FILE_ERROR_UNKNOWN_ENCODING,
'  G_KEY_FILE_ERROR_PARSE,
'  G_KEY_FILE_ERROR_NOT_FOUND,
'  G_KEY_FILE_ERROR_KEY_NOT_FOUND,
'  G_KEY_FILE_ERROR_GROUP_NOT_FOUND,
'  G_KEY_FILE_ERROR_INVALID_VALUE
'} GKeyFileError;

%G_KEY_FILE_ERROR_UNKNOWN_ENCODING = 0
%G_KEY_FILE_ERROR_PARSE            = 1
%G_KEY_FILE_ERROR_NOT_FOUND        = 2
%G_KEY_FILE_ERROR_KEY_NOT_FOUND    = 3
%G_KEY_FILE_ERROR_GROUP_NOT_FOUND  = 4
%G_KEY_FILE_ERROR_INVALID_VALUE    = 5

' ========================================================================================
'#define G_KEY_FILE_ERROR g_key_file_error_quark()
'GQuark g_key_file_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_key_file_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_error_quark" ( _
 ) AS DWORD                                 ' GQuark

DECLARE FUNCTION G_KEY_FILE_ERROR CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_error_quark" ( _
 ) AS DWORD                                 ' GQuark

'typedef struct _GKeyFile GKeyFile;

'typedef enum
'{
'  G_KEY_FILE_NONE              = 0,
'  G_KEY_FILE_KEEP_COMMENTS     = 1 << 0,
'  G_KEY_FILE_KEEP_TRANSLATIONS = 1 << 1
'} GKeyFileFlags;

%G_KEY_FILE_NONE              = 0
%G_KEY_FILE_KEEP_COMMENTS     = &H1
%G_KEY_FILE_KEEP_TRANSLATIONS = &H2

' ========================================================================================
'GKeyFile *g_key_file_new                    (void);
' ========================================================================================
DECLARE FUNCTION g_key_file_new CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_new" ( _
 ) AS DWORD                                 ' GKeyFile*

' ========================================================================================
'void      g_key_file_free                   (GKeyFile             *key_file);
' ========================================================================================
DECLARE SUB g_key_file_free CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_free" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 )                                          ' void

' ========================================================================================
'void      g_key_file_set_list_separator     (GKeyFile             *key_file,
'                                             gchar                 separator);
' ========================================================================================
DECLARE SUB g_key_file_set_list_separator CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_list_separator" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYVAL BYTE _                             ' gchar                 separator
 )                                          ' void

' ========================================================================================
'gboolean  g_key_file_load_from_file         (GKeyFile             *key_file,
'                                             const gchar          *file,
'                                             GKeyFileFlags         flags,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_load_from_file CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_load_from_file" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *file
 , BYVAL DWORD _                            ' GKeyFileFlags         flags
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean  g_key_file_load_from_data         (GKeyFile             *key_file,
'                                             const gchar          *data,
'                                             gsize                 length,
'                                             GKeyFileFlags         flags,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_load_from_data CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_load_from_data" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ANY _                              ' const gchar          *data
 , BYVAL DWORD _                            ' gsize                 length
 , BYVAL DWORD _                            ' GKeyFileFlags         flags
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean g_key_file_load_from_dirs          (GKeyFile             *key_file,
'                                             const gchar          *file,
'                                             const gchar         **search_dirs,
'                                             gchar               **full_path,
'                                             GKeyFileFlags         flags,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_load_from_dirs CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_load_from_dirs" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *file
 , BYREF ASCIIZ _                           ' const gchar         **search_dirs
 , BYREF DWORD _                            ' const gchar         **full_path
 , BYVAL DWORD _                            ' GKeyFileFlags         flags
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean g_key_file_load_from_data_dirs     (GKeyFile             *key_file,
'                                             const gchar          *file,
'                                             gchar               **full_path,
'                                             GKeyFileFlags         flags,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_load_from_data_dirs CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_load_from_data_dirs" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *file
 , BYREF DWORD _                            ' const gchar         **full_path
 , BYVAL DWORD _                            ' GKeyFileFlags         flags
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar    *g_key_file_to_data                (GKeyFile             *key_file,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_to_data CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_to_data" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar    *g_key_file_get_start_group        (GKeyFile             *key_file) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_start_group CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_start_group" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar   **g_key_file_get_groups             (GKeyFile             *key_file,
'                                             gsize                *length) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_groups CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_groups" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF DWORD _                            ' gsize                *length
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gchar   **g_key_file_get_keys               (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_keys CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_keys" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gboolean  g_key_file_has_group              (GKeyFile             *key_file,
'                                             const gchar          *group_name);
' ========================================================================================
DECLARE FUNCTION g_key_file_has_group CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_has_group" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean  g_key_file_has_key                (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_has_key CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_has_key" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar    *g_key_file_get_value              (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_value CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_value" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void      g_key_file_set_value              (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *value);
' ========================================================================================
DECLARE SUB g_key_file_set_value CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_value" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *value
 )                                          ' void

' ========================================================================================
'gchar    *g_key_file_get_string             (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_string CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_string" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void      g_key_file_set_string             (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *string);
' ========================================================================================
DECLARE SUB g_key_file_set_string CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_string" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *string
 )                                          ' void

' ========================================================================================
'gchar    *g_key_file_get_locale_string      (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *locale,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_locale_string CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_locale_string" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *locale
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void      g_key_file_set_locale_string      (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *locale,
'                                             const gchar          *string);
' ========================================================================================
DECLARE SUB g_key_file_set_locale_string CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_locale_string" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *locale
 , BYREF ASCIIZ _                           ' const gchar          *string
 )                                          ' void

' ========================================================================================
'gboolean  g_key_file_get_boolean            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_get_boolean CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_boolean" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void      g_key_file_set_boolean            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gboolean              value);
' ========================================================================================
DECLARE SUB g_key_file_set_boolean CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_boolean" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYVAL LONG _                             ' gboolean              value
 )                                          ' void

' ========================================================================================
'gint      g_key_file_get_integer            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_get_integer CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_integer" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gint

' ========================================================================================
'void      g_key_file_set_integer            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gint                  value);
' ========================================================================================
DECLARE SUB g_key_file_set_integer CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_integer" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYVAL LONG _                             ' gint                  value
 )                                          ' void

' ========================================================================================
'gdouble   g_key_file_get_double             (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_get_double CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_double" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS DOUBLE                                ' gdouble

' ========================================================================================
'void      g_key_file_set_double             (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gdouble               value);
' ========================================================================================
DECLARE SUB g_key_file_set_double CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_double" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYVAL DOUBLE _                           ' gdouble               value
 )                                          ' void

' ========================================================================================
'gchar   **g_key_file_get_string_list        (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_string_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_string_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'void      g_key_file_set_string_list        (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar * const   list[],
'                                             gsize                 length);
' ========================================================================================
DECLARE SUB g_key_file_set_string_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_string_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar * const   list[]
 , BYVAL DWORD _                            ' gsize                 length
 )                                          ' void

' ========================================================================================
'gchar   **g_key_file_get_locale_string_list (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *locale,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_locale_string_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_locale_string_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *locale
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'void      g_key_file_set_locale_string_list (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *locale,
'                                             const gchar * const   list[],
'                                             gsize                 length);
' ========================================================================================
DECLARE SUB g_key_file_set_locale_string_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_locale_string_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF ASCIIZ _                           ' const gchar          *locale
 , BYREF ASCIIZ _                           ' const gchar * const   list[]
 , BYVAL DWORD _                            ' gsize                 length
 )                                          ' void

' ========================================================================================
'gboolean *g_key_file_get_boolean_list       (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_boolean_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_boolean_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gboolean*

' ========================================================================================
'void      g_key_file_set_boolean_list       (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gboolean              list[],
'                                             gsize                 length);
' ========================================================================================
DECLARE SUB g_key_file_set_boolean_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_boolean_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF LONG _                             ' gboolean              list[]
 , BYVAL DWORD _                            ' gsize                 length
 )                                          ' void

' ========================================================================================
'gint     *g_key_file_get_integer_list       (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_integer_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_integer_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gint*

' ========================================================================================
'void      g_key_file_set_double_list        (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gdouble               list[],
'                                             gsize                 length);
' ========================================================================================
DECLARE SUB g_key_file_set_double_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_double_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DOUBLE _                           ' gdouble               list[]
 , BYVAL DWORD _                            ' gsize                 length
 )                                          ' void

' ========================================================================================
'gdouble  *g_key_file_get_double_list        (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gsize                *length,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_double_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_double_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' gsize                *length
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gdouble*


' ========================================================================================
'void      g_key_file_set_integer_list       (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             gint                  list[],
'                                             gsize                 length);
' ========================================================================================
DECLARE SUB g_key_file_set_integer_list CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_integer_list" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF LONG _                             ' gint                  list[]
 , BYVAL DWORD _                            ' gsize                 length
 )                                          ' void

' ========================================================================================
'gboolean  g_key_file_set_comment            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             const gchar          *comment,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_set_comment CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_set_comment" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' gsize                *comment
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gchar    *g_key_file_get_comment            (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_key_file_get_comment CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_get_comment" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gboolean  g_key_file_remove_comment         (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_remove_comment CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_remove_comment" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean  g_key_file_remove_key             (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             const gchar          *key,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_remove_key CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_remove_key" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF ASCIIZ _                           ' const gchar          *key
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean  g_key_file_remove_group           (GKeyFile             *key_file,
'                                             const gchar          *group_name,
'                                             GError              **error);
' ========================================================================================
DECLARE FUNCTION g_key_file_remove_group CDECL LIB $GLIB_DLLNAME ALIAS "g_key_file_remove_group" ( _
   BYVAL DWORD _                            ' GKeyFile             *key_file
 , BYREF ASCIIZ _                           ' const gchar          *group_name
 , BYREF DWORD _                            ' GError              **error
 ) AS LONG                                  ' gboolean

'/* Defines for handling freedesktop.org Desktop files */
'#define G_KEY_FILE_DESKTOP_GROUP                "Desktop Entry"

'#define G_KEY_FILE_DESKTOP_KEY_TYPE             "Type"
'#define G_KEY_FILE_DESKTOP_KEY_VERSION          "Version"
'#define G_KEY_FILE_DESKTOP_KEY_NAME             "Name"
'#define G_KEY_FILE_DESKTOP_KEY_GENERIC_NAME     "GenericName"
'#define G_KEY_FILE_DESKTOP_KEY_NO_DISPLAY       "NoDisplay"
'#define G_KEY_FILE_DESKTOP_KEY_COMMENT          "Comment"
'#define G_KEY_FILE_DESKTOP_KEY_ICON             "Icon"
'#define G_KEY_FILE_DESKTOP_KEY_HIDDEN           "Hidden"
'#define G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN     "OnlyShowIn"
'#define G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN      "NotShowIn"
'#define G_KEY_FILE_DESKTOP_KEY_TRY_EXEC         "TryExec"
'#define G_KEY_FILE_DESKTOP_KEY_EXEC             "Exec"
'#define G_KEY_FILE_DESKTOP_KEY_PATH             "Path"
'#define G_KEY_FILE_DESKTOP_KEY_TERMINAL         "Terminal"
'#define G_KEY_FILE_DESKTOP_KEY_MIME_TYPE        "MimeType"
'#define G_KEY_FILE_DESKTOP_KEY_CATEGORIES       "Categories"
'#define G_KEY_FILE_DESKTOP_KEY_STARTUP_NOTIFY   "StartupNotify"
'#define G_KEY_FILE_DESKTOP_KEY_STARTUP_WM_CLASS "StartupWMClass"
'#define G_KEY_FILE_DESKTOP_KEY_URL              "URL"

'#define G_KEY_FILE_DESKTOP_TYPE_APPLICATION     "Application"
'#define G_KEY_FILE_DESKTOP_TYPE_LINK            "Link"
'#define G_KEY_FILE_DESKTOP_TYPE_DIRECTORY       "Directory"

$G_KEY_FILE_DESKTOP_GROUP                = "Desktop Entry"

$G_KEY_FILE_DESKTOP_KEY_TYPE             = "Type"
$G_KEY_FILE_DESKTOP_KEY_VERSION          = "Version"
$G_KEY_FILE_DESKTOP_KEY_NAME             = "Name"
$G_KEY_FILE_DESKTOP_KEY_GENERIC_NAME     = "GenericName"
$G_KEY_FILE_DESKTOP_KEY_NO_DISPLAY       = "NoDisplay"
$G_KEY_FILE_DESKTOP_KEY_COMMENT          = "Comment"
$G_KEY_FILE_DESKTOP_KEY_ICON             = "Icon"
$G_KEY_FILE_DESKTOP_KEY_HIDDEN           = "Hidden"
$G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN     = "OnlyShowIn"
$G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN      = "NotShowIn"
$G_KEY_FILE_DESKTOP_KEY_TRY_EXEC         = "TryExec"
$G_KEY_FILE_DESKTOP_KEY_EXEC             = "Exec"
$G_KEY_FILE_DESKTOP_KEY_PATH             = "Path"
$G_KEY_FILE_DESKTOP_KEY_TERMINAL         = "Terminal"
$G_KEY_FILE_DESKTOP_KEY_MIME_TYPE        = "MimeType"
$G_KEY_FILE_DESKTOP_KEY_CATEGORIES       = "Categories"
$G_KEY_FILE_DESKTOP_KEY_STARTUP_NOTIFY   = "StartupNotify"
$G_KEY_FILE_DESKTOP_KEY_STARTUP_WM_CLASS = "StartupWMClass"
$G_KEY_FILE_DESKTOP_KEY_URL              = "URL"

$G_KEY_FILE_DESKTOP_TYPE_APPLICATION     = "Application"
$G_KEY_FILE_DESKTOP_TYPE_LINK            = "Link"
$G_KEY_FILE_DESKTOP_TYPE_DIRECTORY      =  "Directory"

'G_END_DECLS

'#endif /* __G_KEY_FILE_H__ */
#ENDIF   ' /* __GKEYFILE_INC__ */
