'/* gmarkup.h - Simple XML-like string parser/writer
' *
' *  Copyright 2000 Red Hat, Inc.
' *
' * GLib is free software; you can redistribute it and/or modify it
' * under the terms of the GNU Lesser General Public License as
' * published by the Free Software Foundation; either version 2 of the
' * License, or (at your option) any later version.
' *
' * GLib is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with GLib; see the file COPYING.LIB.  If not,
' * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' *   Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_MARKUP_H__
'#define __G_MARKUP_H__

#IF NOT %DEF(%GMARKUP_INC)
    %GMARKUP_INC = 1

'#include <stdarg.h>

#INCLUDE ONCE "gerror.inc"
#INCLUDE ONCE "gslist.inc"

'G_BEGIN_DECLS

'typedef enum
'{
'  G_MARKUP_ERROR_BAD_UTF8,
'  G_MARKUP_ERROR_EMPTY,
'  G_MARKUP_ERROR_PARSE,
'  /* The following are primarily intended for specific GMarkupParser
'   * implementations to set.
'   */
'  G_MARKUP_ERROR_UNKNOWN_ELEMENT,
'  G_MARKUP_ERROR_UNKNOWN_ATTRIBUTE,
'  G_MARKUP_ERROR_INVALID_CONTENT,
'  G_MARKUP_ERROR_MISSING_ATTRIBUTE
'} GMarkupError;

%G_MARKUP_ERROR_BAD_UTF8          = 0
%G_MARKUP_ERROR_EMPTY             = 1
%G_MARKUP_ERROR_PARSE             = 2
%G_MARKUP_ERROR_UNKNOWN_ELEMENT   = 3
%G_MARKUP_ERROR_UNKNOWN_ATTRIBUTE = 4
%G_MARKUP_ERROR_INVALID_CONTENT   = 5
%G_MARKUP_ERROR_MISSING_ATTRIBUTE = 6

' ========================================================================================
'#define G_MARKUP_ERROR g_markup_error_quark ()
'GQuark g_markup_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_markup_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_error_quark" ( _
 ) AS DWORD                                 ' GQuark

DECLARE FUNCTION G_MARKUP_ERROR CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_error_quark" ( _
 ) AS DWORD                                 ' GQuark

'typedef enum
'{
'  G_MARKUP_DO_NOT_USE_THIS_UNSUPPORTED_FLAG = 1 << 0,
'  G_MARKUP_TREAT_CDATA_AS_TEXT              = 1 << 1,
'  G_MARKUP_PREFIX_ERROR_POSITION            = 1 << 2
'} GMarkupParseFlags;

%G_MARKUP_DO_NOT_USE_THIS_UNSUPPORTED_FLAG = &H1
%G_MARKUP_TREAT_CDATA_AS_TEXT              = &H2
%G_MARKUP_PREFIX_ERROR_POSITION            = &H4

'typedef struct _GMarkupParseContext GMarkupParseContext;
'typedef struct _GMarkupParser GMarkupParser;

'struct _GMarkupParser
'{
'  /* Called for open tags <foo bar="baz"> */
'  void (*start_element)  (GMarkupParseContext *context,
'                          const gchar         *element_name,
'                          const gchar        **attribute_names,
'                          const gchar        **attribute_values,
'                          gpointer             user_data,
'                          GError             **error);

'  /* Called for close tags </foo> */
'  void (*end_element)    (GMarkupParseContext *context,
'                          const gchar         *element_name,
'                          gpointer             user_data,
'                          GError             **error);

'  /* Called for character data */
'  /* text is not nul-terminated */
'  void (*text)           (GMarkupParseContext *context,
'                          const gchar         *text,
'                          gsize                text_len,
'                          gpointer             user_data,
'                          GError             **error);

'  /* Called for strings that should be re-saved verbatim in this same
'   * position, but are not otherwise interpretable.  At the moment
'   * this includes comments and processing instructions.
'   */
'  /* text is not nul-terminated. */
'  void (*passthrough)    (GMarkupParseContext *context,
'                          const gchar         *passthrough_text,
'                          gsize                text_len,
'                          gpointer             user_data,
'                          GError             **error);

'  /* Called on error, including one set by other
'   * methods in the vtable. The GError should not be freed.
'   */
'  void (*error)          (GMarkupParseContext *context,
'                          GError              *error,
'                          gpointer             user_data);
'};

TYPE GMarkupParser
   start_element AS DWORD
   end_element   AS DWORD
   text          AS DWORD
   passthrough   AS DWORD
   error         AS DWORD
END TYPE

' ========================================================================================
'GMarkupParseContext *g_markup_parse_context_new   (const GMarkupParser *parser,
'                                                   GMarkupParseFlags    flags,
'                                                   gpointer             user_data,
'                                                   GDestroyNotify       user_data_dnotify);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_new CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_new" ( _
   BYVAL GMarkupParser PTR _                ' const GMarkupParser *parser
 , BYVAL DWORD _                            ' GMarkupParseFlags    flags
 , BYVAL DWORD _                            ' gpointer             user_data
 , BYVAL DWORD _                            ' GDestroyNotify       user_data_dnotify
 ) AS DWORD                                 ' GMarkupParseContext*

' ========================================================================================
'void                 g_markup_parse_context_free  (GMarkupParseContext *context);
' ========================================================================================
DECLARE SUB g_markup_parse_context_free CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_free" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 )                                          ' void

' ========================================================================================
'gboolean             g_markup_parse_context_parse (GMarkupParseContext *context,
'                                                   const gchar         *text,
'                                                   gssize               text_len,
'                                                   GError             **error);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_parse CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_parse" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 , BYREF ASCIIZ _                           ' const gchar         *text
 , BYVAL LONG _                             ' gssize               text_len
 , BYREF DWORD _                            ' GError             **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void                 g_markup_parse_context_push  (GMarkupParseContext *context,
'                                                   GMarkupParser       *parser,
'                                                   gpointer             user_data);
' ========================================================================================
DECLARE SUB g_markup_parse_context_push CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_push" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 , BYVAL GMarkupParser PTR _                ' GMarkupParser       *parser
 , BYVAL DWORD _                            ' gpointer             user_data
 )                                          ' void

' ========================================================================================
'gpointer             g_markup_parse_context_pop   (GMarkupParseContext *context);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_pop CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_pop" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gboolean             g_markup_parse_context_end_parse (GMarkupParseContext *context,
'                                                       GError             **error);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_end_parse CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_end_parse" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 , BYREF DWORD _                            ' GError             **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'G_CONST_RETURN gchar *g_markup_parse_context_get_element (GMarkupParseContext *context);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_get_element CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_get_element" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN GSList *g_markup_parse_context_get_element_stack (GMarkupParseContext *context);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_get_element_stack CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_get_element_stack" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 ) AS DWORD                                 ' GSList*

'/* For user-constructed error messages, has no precise semantics */

' ========================================================================================
'void                 g_markup_parse_context_get_position (GMarkupParseContext *context,
'                                                          gint                *line_number,
'                                                          gint                *char_number);
' ========================================================================================
DECLARE SUB g_markup_parse_context_get_position CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_get_position" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 , BYVAL LONG _                             ' gint                *line_number
 , BYVAL LONG _                             ' gint                *char_number
 )                                          ' void

' ========================================================================================
'gpointer             g_markup_parse_context_get_user_data (GMarkupParseContext *context);
' ========================================================================================
DECLARE FUNCTION g_markup_parse_context_get_user_data CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_parse_context_get_user_data" ( _
   BYVAL DWORD _                            ' GMarkupParseContext *context
 ) AS DWORD                                 ' gpointer

'/* useful when saving */

' ========================================================================================
'gchar* g_markup_escape_text (const gchar *text,
'                             gssize       length);
' ========================================================================================
DECLARE FUNCTION g_markup_escape_text CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_escape_text" ( _
   BYREF ASCIIZ _                           ' const gchar *text
 , BYVAL LONG _                             ' gssize       length
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *g_markup_printf_escaped (const char *format,
'                                ...) G_GNUC_PRINTF (1, 2);
' ========================================================================================
DECLARE FUNCTION g_markup_printf_escaped CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_printf_escaped" ( _
   BYREF ASCIIZ _                           ' const gchar *format
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *g_markup_vprintf_escaped (const char *format,
'                                 va_list     args);
' ========================================================================================
DECLARE FUNCTION g_markup_vprintf_escaped CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_vprintf_escaped" ( _
   BYREF ASCIIZ _                           ' const gchar *format
 , BYREF ANY _                              ' va_list     args
 ) AS DWORD                                 ' gchar*

'typedef enum
'{
'  G_MARKUP_COLLECT_INVALID,
'  G_MARKUP_COLLECT_STRING,
'  G_MARKUP_COLLECT_STRDUP,
'  G_MARKUP_COLLECT_BOOLEAN,
'  G_MARKUP_COLLECT_TRISTATE,

'  G_MARKUP_COLLECT_OPTIONAL = (1 << 16)
'} GMarkupCollectType;

%G_MARKUP_COLLECT_INVALID  = 0
%G_MARKUP_COLLECT_STRING   = 1
%G_MARKUP_COLLECT_STRDUP   = 2
%G_MARKUP_COLLECT_BOOLEAN  = 3
%G_MARKUP_COLLECT_TRISTATE = 4

%G_MARKUP_COLLECT_OPTIONAL = &H10000

'/* useful from start_element */

' ========================================================================================
'gboolean   g_markup_collect_attributes (const gchar         *element_name,
'                                        const gchar        **attribute_names,
'                                        const gchar        **attribute_values,
'                                        GError             **error,
'                                        GMarkupCollectType   first_type,
'                                        const gchar         *first_attr,
'                                        ...);
' ========================================================================================
DECLARE FUNCTION g_markup_collect_attributes CDECL LIB $GLIB_DLLNAME ALIAS "g_markup_collect_attributes" ( _
   BYREF ASCIIZ _                           ' const gchar         *element_name
 , BYREF ASCIIZ _                           ' const gchar        **attribute_names
 , BYREF ASCIIZ _                           ' const gchar        **attribute_values
 , BYREF DWORD _                            ' GError             **error
 , BYVAL LONG _                             ' GMarkupCollectType   first_type
 , BYREF ASCIIZ _                           ' const gchar         *first_attr
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS LONG                                  ' gboolean

'G_END_DECLS

'#endif /* __G_MARKUP_H__ */
#ENDIF   ' /* __GMARKUP_INC__ */
