'/* goption.h - Option parser
' *
' *  Copyright (C) 2004  Anders Carlsson <andersca@gnome.org>
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Library General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Library General Public License for more details.
' *
' * You should have received a copy of the GNU Library General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_OPTION_H__
'#define __G_OPTION_H__

#IF NOT %DEF(%GOPTION_INC)
    %GOPTION_INC = 1

#INCLUDE ONCE "gerror.inc"
#INCLUDE ONCE "gquark.inc"

'G_BEGIN_DECLS

'typedef struct _GOptionContext GOptionContext;
'typedef struct _GOptionGroup   GOptionGroup;
'typedef struct _GOptionEntry   GOptionEntry;

'typedef enum
'{
'  G_OPTION_FLAG_HIDDEN       = 1 << 0,
'  G_OPTION_FLAG_IN_MAIN      = 1 << 1,
'  G_OPTION_FLAG_REVERSE      = 1 << 2,
'  G_OPTION_FLAG_NO_ARG       = 1 << 3,
'  G_OPTION_FLAG_FILENAME     = 1 << 4,
'  G_OPTION_FLAG_OPTIONAL_ARG = 1 << 5,
'  G_OPTION_FLAG_NOALIAS      = 1 << 6
'} GOptionFlags;

%G_OPTION_FLAG_HIDDEN       = &H1
%G_OPTION_FLAG_IN_MAIN      = &H2
%G_OPTION_FLAG_REVERSE      = &H4
%G_OPTION_FLAG_NO_ARG       = &H8
%G_OPTION_FLAG_FILENAME     = &H10
%G_OPTION_FLAG_OPTIONAL_ARG = &H20
%G_OPTION_FLAG_NOALIAS      = &H40

'typedef enum
'{
'  G_OPTION_ARG_NONE,
'  G_OPTION_ARG_STRING,
'  G_OPTION_ARG_INT,
'  G_OPTION_ARG_CALLBACK,
'  G_OPTION_ARG_FILENAME,
'  G_OPTION_ARG_STRING_ARRAY,
'  G_OPTION_ARG_FILENAME_ARRAY,
'  G_OPTION_ARG_DOUBLE,
'  G_OPTION_ARG_INT64
'} GOptionArg;

%G_OPTION_ARG_NONE           = 0
%G_OPTION_ARG_STRING         = 1
%G_OPTION_ARG_INT            = 2
%G_OPTION_ARG_CALLBACK       = 3
%G_OPTION_ARG_FILENAME       = 4
%G_OPTION_ARG_STRING_ARRAY   = 5
%G_OPTION_ARG_FILENAME_ARRAY = 6
%G_OPTION_ARG_DOUBLE         = 7
%G_OPTION_ARG_INT64          = 8

'typedef gboolean (*GOptionArgFunc) (const gchar    *option_name,
'                                    const gchar    *value,
'                                    gpointer        data,
'                                    GError        **error);

'FUNCTION GOptionArgFunc (BYREF option_name AS ASCIIZ, BYREF value AS ASCIIZ, BYVAL pdata AS DWORD, BYREF dwerror AS DWORD) AS LONG

'typedef gboolean (*GOptionParseFunc) (GOptionContext *context,
'                                      GOptionGroup   *group,
'                                      gpointer         data,
'                                      GError        **error);

'FUNCTION GOptionParseFunc (BYVAL context AS DWORD, BYVAL group AS DWORD, BYVAL pdata AS DWORD, BYREF dwerror AS DWORD) AS LONG

'typedef void (*GOptionErrorFunc) (GOptionContext *context,
'              GOptionGroup   *group,
'              gpointer        data,
'              GError        **error);

'SUB GOptionErrorFunc (BYVAL context AS DWORD, BYVAL group AS DWORD, BYVAL pdata AS DWORD, BYREF dwerror AS DWORD)

'#define G_OPTION_ERROR (g_option_error_quark ())

'typedef enum
'{
'  G_OPTION_ERROR_UNKNOWN_OPTION,
'  G_OPTION_ERROR_BAD_VALUE,
'  G_OPTION_ERROR_FAILED
'} GOptionError;

%G_OPTION_ERROR_UNKNOWN_OPTION = 0
%G_OPTION_ERROR_BAD_VALUE      = 1
%G_OPTION_ERROR_FAILED         = 2

' ========================================================================================
'GQuark g_option_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_option_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_option_error_quark" ( _
 ) AS DWORD                                 ' GQuark

DECLARE FUNCTION G_OPTION_ERROR CDECL LIB $GLIB_DLLNAME ALIAS "g_option_error_quark" ( _
 ) AS DWORD                                 ' GQuark


'struct _GOptionEntry
'{
'  const gchar *long_name;
'  gchar        short_name;
'  gint         flags;

'  GOptionArg   arg;
'  gpointer     arg_data;

'  const gchar *description;
'  const gchar *arg_description;
'};

TYPE GOptionEntry
   long_name       AS ASCIIZ PTR
   short_name      AS BYTE
   flags           AS LONG
   arg             AS LONG
   arg_data        AS DWORD
   description     AS ASCIIZ PTR
   arg_description AS ASCIIZ PTR
END TYPE

'#define G_OPTION_REMAINING ""
$G_OPTION_REMAINING = ""

' ========================================================================================
'GOptionContext *g_option_context_new              (const gchar         *parameter_string);
' ========================================================================================
DECLARE FUNCTION g_option_context_new CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_new" ( _
   BYREF ASCIIZ _                           ' const gchar         *parameter_string
 ) AS DWORD                                 ' GOptionContext*

' ========================================================================================
'void            g_option_context_set_summary      (GOptionContext      *context,
'                                                   const gchar         *summary);
' ========================================================================================
DECLARE SUB g_option_context_set_summary CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_summary" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYREF ASCIIZ _                           ' const gchar         *summary
 )                                          ' void

' ========================================================================================
'G_CONST_RETURN gchar *g_option_context_get_summary (GOptionContext     *context);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_summary CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_summary" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void            g_option_context_set_description  (GOptionContext      *context,
'                                                   const gchar         *description);
' ========================================================================================
DECLARE SUB g_option_context_set_description CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_description" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYREF ASCIIZ _                           ' const gchar         *description
 )                                          ' void

' ========================================================================================
'G_CONST_RETURN gchar *g_option_context_get_description (GOptionContext     *context);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_description CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_description" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void            g_option_context_free             (GOptionContext      *context);
' ========================================================================================
DECLARE SUB g_option_context_free CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_free" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 )                                          ' void

' ========================================================================================
'void      g_option_context_set_help_enabled (GOptionContext      *context,
'                                             gboolean             help_enabled);
' ========================================================================================
DECLARE SUB g_option_context_set_help_enabled CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_help_enabled" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYVAL LONG _                             ' gboolean             help_enabled
 )                                          ' void

' ========================================================================================
'gboolean   g_option_context_get_help_enabled (GOptionContext      *context);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_help_enabled CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_help_enabled" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void      g_option_context_set_ignore_unknown_options (GOptionContext *context,
'                                                       gboolean        ignore_unknown);
' ========================================================================================
DECLARE SUB g_option_context_set_ignore_unknown_options CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_ignore_unknown_options" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYVAL LONG _                             ' gboolean             ignore_unknown
 )                                          ' void

' ========================================================================================
'gboolean        g_option_context_get_ignore_unknown_options (GOptionContext *context);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_ignore_unknown_options CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_ignore_unknown_options" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void            g_option_context_add_main_entries (GOptionContext      *context,
'                                                   const GOptionEntry  *entries,
'                                                   const gchar         *translation_domain);
' ========================================================================================
DECLARE SUB g_option_context_add_main_entries CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_add_main_entries" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYREF DWORD _                            ' gboolean            *entries
 , BYREF ASCIIZ _                           ' const gchar         *translation_domain
 )                                          ' void

' ========================================================================================
'gboolean        g_option_context_parse            (GOptionContext      *context,
'                                                   gint                *argc,
'                                                   gchar             ***argv,
'                                                   GError             **error);
' ========================================================================================
DECLARE FUNCTION g_option_context_parse CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_parse" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 , BYVAL LONG _                             ' gint                *argc
 , BYREF DWORD _                            ' gchar             ***argv
 , BYREF DWORD _                            ' GError             **error
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void            g_option_context_set_translate_func (GOptionContext     *context,
'                                                     GTranslateFunc      func,
'                                                     gpointer            data,
'                                                     GDestroyNotify      destroy_notify);
' ========================================================================================
DECLARE SUB g_option_context_set_translate_func CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_translate_func" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYVAL DWORD _                            ' GTranslateFunc      func
 , BYVAL DWORD _                            ' gpointer            data
 , BYVAL DWORD _                            ' GDestroyNotify      destroy_notify
 )                                          ' void

' ========================================================================================
'void            g_option_context_set_translation_domain (GOptionContext  *context,
'                                                         const gchar     *domain);
' ========================================================================================
DECLARE SUB g_option_context_set_translation_domain CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_translation_domain" ( _
   BYVAL DWORD _                            ' GOptionContext      *context
 , BYREF ASCIIZ _                           ' const gchar     *domain
 )                                          ' void

' ========================================================================================
'void            g_option_context_add_group      (GOptionContext *context,
'                                                 GOptionGroup   *group);
' ========================================================================================
DECLARE SUB g_option_context_add_group CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_add_group" ( _
   BYVAL DWORD _                            ' GOptionContext *context
 , BYVAL DWORD _                            ' GOptionGroup   *group
 )                                          ' void

' ========================================================================================
'void          g_option_context_set_main_group (GOptionContext *context,
'                                               GOptionGroup   *group);
' ========================================================================================
DECLARE SUB g_option_context_set_main_group CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_set_main_group" ( _
   BYVAL DWORD _                            ' GOptionContext *context
 , BYVAL DWORD _                            ' GOptionGroup   *group
 )                                          ' void

' ========================================================================================
'GOptionGroup *g_option_context_get_main_group (GOptionContext *context);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_main_group CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_main_group" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 ) AS DWORD                                 ' GOptionGroup

' ========================================================================================
'gchar        *g_option_context_get_help       (GOptionContext *context,
'                                               gboolean        main_help,
'                                               GOptionGroup   *group);
' ========================================================================================
DECLARE FUNCTION g_option_context_get_help CDECL LIB $GLIB_DLLNAME ALIAS "g_option_context_get_help" ( _
   BYREF DWORD _                            ' GOptionContext     *context
 , BYVAL LONG _                             ' gboolean        main_help
 , BYVAL DWORD _                            ' GOptionGroup   *group
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'GOptionGroup *g_option_group_new                    (const gchar        *name,
'                                                     const gchar        *description,
'                                                     const gchar        *help_description,
'                                                     gpointer            user_data,
'                                                     GDestroyNotify      destroy);
' ========================================================================================
DECLARE FUNCTION g_option_group_new CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_new" ( _
   BYREF ASCIIZ _                           ' const gchar        *name
 , BYREF ASCIIZ _                           ' const gchar        *description
 , BYREF ASCIIZ _                           ' const gchar        *help_description
 , BYVAL DWORD _                            ' gpointer            user_data
 , BYVAL DWORD _                            ' GDestroyNotify      destroy
 ) AS DWORD                                 ' GOptionGroup

' ========================================================================================
'void         g_option_group_set_parse_hooks       (GOptionGroup       *group,
'                                                   GOptionParseFunc    pre_parse_func,
'                                                   GOptionParseFunc    post_parse_func);
' ========================================================================================
DECLARE SUB g_option_group_set_parse_hooks CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_set_parse_hooks" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 , BYVAL DWORD _                            ' GOptionParseFunc    pre_parse_func
 , BYVAL DWORD _                            ' GOptionParseFunc    post_parse_func
 )                                          ' void

' ========================================================================================
'void         g_option_group_set_error_hook       (GOptionGroup       *group,
'                                                  GOptionErrorFunc    error_func);
' ========================================================================================
DECLARE SUB g_option_group_set_error_hook CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_set_error_hook" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 , BYVAL DWORD _                            ' GOptionErrorFunc    error_func
 )                                          ' void

' ========================================================================================
'void          g_option_group_free                   (GOptionGroup       *group);
' ========================================================================================
DECLARE SUB g_option_group_free CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_free" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 )                                          ' void

' ========================================================================================
'void          g_option_group_add_entries            (GOptionGroup       *group,
'                                                     const GOptionEntry *entries);
' ========================================================================================
DECLARE SUB g_option_group_add_entries CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_add_entries" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 , BYREF DWORD _                            ' const GOptionEntry *entries
 )                                          ' void

' ========================================================================================
'void          g_option_group_set_translate_func     (GOptionGroup       *group,
'                                                     GTranslateFunc      func,
'                                                     gpointer            data,
'                                                     GDestroyNotify      destroy_notify);
' ========================================================================================
DECLARE SUB g_option_group_set_translate_func CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_set_translate_func" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 , BYVAL DWORD _                            ' GTranslateFunc      func
 , BYVAL DWORD _                            ' gpointer            data
 , BYVAL DWORD _                            ' GDestroyNotify      destroy_notify
 )                                          ' void

' ========================================================================================
'void          g_option_group_set_translation_domain (GOptionGroup       *group,
'                                                     const gchar        *domain);
' ========================================================================================
DECLARE SUB g_option_group_set_translation_domain CDECL LIB $GLIB_DLLNAME ALIAS "g_option_group_set_translation_domain" ( _
   BYVAL DWORD _                            ' GOptionGroup       *group
 , BYREF ASCIIZ _                           ' const gchar        *domain
 )                                          ' void

'G_END_DECLS

'#endif /* __G_OPTION_H__ */
#ENDIF   ' /* __GOPTION_INC__ */
