'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997, 1999  Peter Mattis, Red Hat, Inc.
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_PATTERN_H__
'#define __G_PATTERN_H__

#IF NOT %DEF(%GPATTERN_INC)
    %GPATTERN_INC = 1

#INCLUDE ONCE "gtypes.inc"

'G_BEGIN_DECLS


'typedef struct _GPatternSpec    GPatternSpec;

' ========================================================================================
'GPatternSpec* g_pattern_spec_new       (const gchar  *pattern);
' ========================================================================================
DECLARE FUNCTION g_pattern_spec_new CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_spec_new" ( _
   BYREF ASCIIZ _                           ' const gchar *pattern
 ) AS DWORD                                 ' GPatternSpec*

' ========================================================================================
'void          g_pattern_spec_free      (GPatternSpec *pspec);
' ========================================================================================
DECLARE SUB g_pattern_spec_free CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_spec_free" ( _
   BYVAL DWORD _                            ' GPatternSpec *pspec
 )                                          ' void

' ========================================================================================
'gboolean      g_pattern_spec_equal     (GPatternSpec *pspec1,
'                                        GPatternSpec *pspec2);
' ========================================================================================
DECLARE FUNCTION g_pattern_spec_equal CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_spec_equal" ( _
   BYVAL DWORD _                            ' GPatternSpec *pspec1
 , BYVAL DWORD _                            ' GPatternSpec *pspec2
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean      g_pattern_match          (GPatternSpec *pspec,
'                                        guint         string_length,
'                                        const gchar  *string,
'                                        const gchar  *string_reversed);
' ========================================================================================
DECLARE FUNCTION g_pattern_match CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_match" ( _
   BYVAL DWORD _                            ' GPatternSpec *pspec
 , BYVAL DWORD _                            ' guint         string_length
 , BYREF ASCIIZ _                           ' const gchar  *string
 , BYREF ASCIIZ _                           ' const gchar  *string_reversed
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean      g_pattern_match_string   (GPatternSpec *pspec,
'                                        const gchar  *string);
' ========================================================================================
DECLARE FUNCTION g_pattern_match_string CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_match_string" ( _
   BYVAL DWORD _                            ' GPatternSpec *pspec
 , BYREF ASCIIZ _                           ' const gchar  *string
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean      g_pattern_match_simple   (const gchar  *pattern,
'                                        const gchar  *string);
' ========================================================================================
DECLARE FUNCTION g_pattern_match_simple CDECL LIB $GLIB_DLLNAME ALIAS "g_pattern_match_simple" ( _
   BYREF ASCIIZ _                           ' const gchar  *pattern
 , BYREF ASCIIZ _                           ' const gchar  *string
 ) AS LONG                                  ' gboolean

'G_END_DECLS

'#endif /* __G_PATTERN_H__ */
#ENDIF   ' /* __GPATTERN_INC__ */
