'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

#IF NOT %DEF(%GQUEUE_INC)
    %GQUEUE_INC = 1

#INCLUDE ONCE "glist.inc"

'G_BEGIN_DECLS

'typedef struct _GQueue      GQueue;

'struct _GQueue
'{
'  GList *head;
'  GList *tail;
'  guint  length;
'};

TYPE GQueue
   head   AS GList PTR
   tail   AS GList PTR
   length AS DWORD
END TYPE

'#define G_QUEUE_INIT { NULL, NULL, 0 }

'/* Queues
' */
' ========================================================================================
'GQueue*  g_queue_new            (void);
' ========================================================================================
DECLARE FUNCTION g_queue_new CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_new" ( _
 ) AS DWORD                                 ' GQueue*

' ========================================================================================
'void     g_queue_free           (GQueue           *queue);
' ========================================================================================
DECLARE SUB g_queue_free CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_free" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 )                                          ' void

' ========================================================================================
'void     g_queue_init           (GQueue           *queue);
' ========================================================================================
DECLARE SUB g_queue_init CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_init" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 )                                          ' void

' ========================================================================================
'void     g_queue_clear          (GQueue           *queue);
' ========================================================================================
DECLARE SUB g_queue_clear CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_clear" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 )                                          ' void

' ========================================================================================
'gboolean g_queue_is_empty       (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_is_empty CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_is_empty" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS LONG                                  ' gboolean

' ========================================================================================
'guint    g_queue_get_length     (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_get_length CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_get_length" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' guint

' ========================================================================================
'void     g_queue_reverse        (GQueue           *queue);
' ========================================================================================
DECLARE SUB g_queue_reverse CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_reverse" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 )                                          ' void

' ========================================================================================
'GQueue * g_queue_copy           (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_copy CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_copy" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' GQueue*

' ========================================================================================
'void     g_queue_foreach        (GQueue           *queue,
'                                 GFunc             func,
'                                 gpointer          user_data);
' ========================================================================================
DECLARE SUB g_queue_foreach CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_foreach" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' GFunc             func
 , BYVAL DWORD _                            ' gpointer          user_data
 )                                          ' void

' ========================================================================================
'GList *  g_queue_find           (GQueue           *queue,
'                                 gconstpointer     data);
' ========================================================================================
DECLARE FUNCTION g_queue_find CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_find" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList *  g_queue_find_custom    (GQueue           *queue,
'                                 gconstpointer     data,
'                                 GCompareFunc      func);
' ========================================================================================
DECLARE FUNCTION g_queue_find_custom CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_find_custom" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gconstpointer     data
 , BYVAL DWORD _                            ' GCompareFunc      func
 ) AS DWORD                                 ' GList*

' ========================================================================================
'void     g_queue_sort           (GQueue           *queue,
'                                 GCompareDataFunc  compare_func,
'                                 gpointer          user_data);
' ========================================================================================
DECLARE SUB g_queue_sort CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_sort" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' GCompareDataFunc  compare_func
 , BYVAL DWORD _                            ' gpointer          user_data
 )                                          ' void

' ========================================================================================
'void     g_queue_push_head      (GQueue           *queue,
'                                 gpointer          data);
' ========================================================================================
DECLARE SUB g_queue_push_head CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_head" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gpointer          data
 )                                          ' void

' ========================================================================================
'void     g_queue_push_tail      (GQueue           *queue,
'                                 gpointer          data);
' ========================================================================================
DECLARE SUB g_queue_push_tail CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_tail" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gpointer          data
 )                                          ' void

' ========================================================================================
'void     g_queue_push_nth       (GQueue           *queue,
'                                 gpointer          data,
'                                 gint              n);
' ========================================================================================
DECLARE SUB g_queue_push_nth CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_nth" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gpointer          data
 , BYVAL LONG _                             ' gint              n
 )                                          ' void

' ========================================================================================
'gpointer g_queue_pop_head       (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_head CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_head" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gpointer g_queue_pop_tail       (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_tail CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_tail" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gpointer g_queue_pop_nth        (GQueue           *queue,
'                                 guint             n);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_nth CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_nth" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gpointer g_queue_peek_head      (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_head CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_head" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gpointer g_queue_peek_tail      (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_tail CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_tail" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gpointer g_queue_peek_nth       (GQueue           *queue,
'                                 guint             n);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_nth CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_nth" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gint     g_queue_index          (GQueue           *queue,
'                                 gconstpointer     data);
' ========================================================================================
DECLARE FUNCTION g_queue_index CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_index" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS LONG                                  ' gint

' ========================================================================================
'void     g_queue_remove         (GQueue           *queue,
'                                 gconstpointer     data);
' ========================================================================================
DECLARE SUB g_queue_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_remove" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gconstpointer     data
 )                                          ' void

' ========================================================================================
'void     g_queue_remove_all     (GQueue           *queue,
'                                 gconstpointer     data);
' ========================================================================================
DECLARE SUB g_queue_remove_all CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_remove_all" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gconstpointer     data
 )                                          ' void

' ========================================================================================
'void     g_queue_insert_before  (GQueue           *queue,
'                                 GList            *sibling,
'                                 gpointer          data);
' ========================================================================================
DECLARE SUB g_queue_insert_before CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_insert_before" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *sibling
 , BYVAL DWORD _                            ' gpointer          data
 )                                          ' void

' ========================================================================================
'void     g_queue_insert_after   (GQueue           *queue,
'                                 GList            *sibling,
'                                 gpointer          data);
' ========================================================================================
DECLARE SUB g_queue_insert_after CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_insert_after" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *sibling
 , BYVAL DWORD _                            ' gpointer          data
 )                                          ' void

' ========================================================================================
'void     g_queue_insert_sorted  (GQueue           *queue,
'                                 gpointer          data,
'                                 GCompareDataFunc  func,
'                                 gpointer          user_data);
' ========================================================================================
DECLARE SUB g_queue_insert_sorted CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_insert_sorted" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' gpointer          data
 , BYVAL DWORD _                            ' GCompareDataFunc  func
 , BYVAL DWORD _                            ' gpointer          user_data
 )                                          ' void

' ========================================================================================
'void     g_queue_push_head_link (GQueue           *queue,
'                                 GList            *link_);
' ========================================================================================
DECLARE SUB g_queue_push_head_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_head_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *link_
 )                                          ' void

' ========================================================================================
'void     g_queue_push_tail_link (GQueue           *queue,
'                                 GList            *link_);
' ========================================================================================
DECLARE SUB g_queue_push_tail_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_tail_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *link_
 )                                          ' void

' ========================================================================================
'void     g_queue_push_nth_link  (GQueue           *queue,
'                                 gint              n,
'                                 GList            *link_);
' ========================================================================================
DECLARE SUB g_queue_push_nth_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_push_nth_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL LONG _                             ' gint              n
 , BYVAL GList PTR _                        ' GList            *link_
 )                                          ' void

' ========================================================================================
'GList*   g_queue_pop_head_link  (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_head_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_head_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList*   g_queue_pop_tail_link  (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_tail_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_tail_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList*   g_queue_pop_nth_link   (GQueue           *queue,
'                                 guint             n);
' ========================================================================================
DECLARE FUNCTION g_queue_pop_nth_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_pop_nth_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList*   g_queue_peek_head_link (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_head_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_head_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList*   g_queue_peek_tail_link (GQueue           *queue);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_tail_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_tail_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 ) AS DWORD                                 ' GList*

' ========================================================================================
'GList*   g_queue_peek_nth_link  (GQueue           *queue,
'                                 guint             n);
' ========================================================================================
DECLARE FUNCTION g_queue_peek_nth_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_peek_nth_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' GList*

' ========================================================================================
'gint     g_queue_link_index     (GQueue           *queue,
'                                 GList            *link_);
' ========================================================================================
DECLARE FUNCTION g_queue_link_index CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_link_index" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *link_
 ) AS LONG                                  ' gint

' ========================================================================================
'void     g_queue_unlink         (GQueue           *queue,
'                                 GList            *link_);
' ========================================================================================
DECLARE SUB g_queue_unlink CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_unlink" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *link_
 )                                          ' void

' ========================================================================================
'void     g_queue_delete_link    (GQueue           *queue,
'                                 GList            *link_);
' ========================================================================================
DECLARE SUB g_queue_delete_link CDECL LIB $GLIB_DLLNAME ALIAS "g_queue_delete_link" ( _
   BYVAL GQueue PTR _                       ' GQueue           *queue
 , BYVAL GList PTR _                        ' GList            *link_
 )                                          ' void

'G_END_DECLS

'#endif /* __G_QUEUE_H__ */
#ENDIF   ' /* __GQUEUE_INC__ */
