'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_REL_H__
'#define __G_REL_H__

#IF NOT %DEF(%GREL_INC)
    %GREL_INC = 1

#INCLUDE ONCE "gtypes.inc"

'G_BEGIN_DECLS

'typedef struct _GRelation       GRelation;
'typedef struct _GTuples         GTuples;

'struct _GTuples
'{
'  guint len;
'};

TYPE GTuples
   len AS DWORD
END TYPE

'/* GRelation
' *
' * Indexed Relations.  Imagine a really simple table in a
' * database.  Relations are not ordered.  This data type is meant for
' * maintaining a N-way mapping.
' *
' * g_relation_new() creates a relation with FIELDS fields
' *
' * g_relation_destroy() frees all resources
' * g_tuples_destroy() frees the result of g_relation_select()
' *
' * g_relation_index() indexes relation FIELD with the provided
' *   equality and hash functions.  this must be done before any
' *   calls to insert are made.
' *
' * g_relation_insert() inserts a new tuple.  you are expected to
' *   provide the right number of fields.
' *
' * g_relation_delete() deletes all relations with KEY in FIELD
' * g_relation_select() returns ...
' * g_relation_count() counts ...
' */

' ========================================================================================
'GRelation* g_relation_new     (gint         fields);
' ========================================================================================
DECLARE FUNCTION g_relation_new CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_new" ( _
   BYVAL LONG _                             ' gint         fields
 ) AS DWORD                                 ' GRelation*

' ========================================================================================
'void       g_relation_destroy (GRelation   *relation);
' ========================================================================================
DECLARE SUB g_relation_destroy CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_destroy" ( _
   BYVAL DWORD _                            ' GRelation   *relation
 )                                          ' void

' ========================================================================================
'void       g_relation_index   (GRelation   *relation,
'                               gint         field,
'                               GHashFunc    hash_func,
'                               GEqualFunc   key_equal_func);
' ========================================================================================
DECLARE SUB g_relation_index CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_index" ( _
   BYVAL DWORD _                            ' GRelation   *relation
 , BYVAL LONG _                             ' gint         field
 , BYVAL DWORD _                            ' GHashFunc    hash_func
 , BYVAL DWORD _                            ' GEqualFunc   key_equal_func
 )                                          ' void

' ========================================================================================
'void       g_relation_insert  (GRelation   *relation,
'                               ...);
' ========================================================================================
DECLARE SUB g_relation_insert CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_insert" ( _
   BYVAL DWORD _                            ' GRelation   *relation
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 )                                          ' void

' ========================================================================================
'gint       g_relation_delete  (GRelation     *relation,
'                               gconstpointer  key,
'                               gint           field);
' ========================================================================================
DECLARE FUNCTION g_relation_delete CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_delete" ( _
   BYVAL DWORD _                            ' GRelation     *relation
 , BYVAL DWORD _                            ' gconstpointer  key
 , BYVAL LONG _                             ' gint           field
 ) AS LONG                                  ' gint

' ========================================================================================
'GTuples*   g_relation_select  (GRelation     *relation,
'                               gconstpointer  key,
'                               gint           field);
' ========================================================================================
DECLARE FUNCTION g_relation_select CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_select" ( _
   BYVAL DWORD _                            ' GRelation     *relation
 , BYVAL DWORD _                            ' gconstpointer  key
 , BYVAL LONG _                             ' gint           field
 ) AS DWORD                                 ' GTuples*

' ========================================================================================
'gint       g_relation_count   (GRelation     *relation,
'                               gconstpointer  key,
'                               gint           field);
' ========================================================================================
DECLARE FUNCTION g_relation_count CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_count" ( _
   BYVAL DWORD _                            ' GRelation     *relation
 , BYVAL DWORD _                            ' gconstpointer  key
 , BYVAL LONG _                             ' gint           field
 ) AS LONG                                  ' gint

' ========================================================================================
'gboolean   g_relation_exists  (GRelation   *relation,
'                               ...);
' ========================================================================================
DECLARE FUNCTION g_relation_exists CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_exists" ( _
   BYVAL DWORD _                            ' GRelation     *relation
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void       g_relation_print   (GRelation   *relation);
' ========================================================================================
DECLARE SUB g_relation_print CDECL LIB $GLIB_DLLNAME ALIAS "g_relation_print" ( _
   BYVAL DWORD _                            ' GRelation   *relation
 )                                          ' void

' ========================================================================================
'void       g_tuples_destroy   (GTuples     *tuples);
' ========================================================================================
DECLARE SUB g_tuples_destroy CDECL LIB $GLIB_DLLNAME ALIAS "g_tuples_destroy" ( _
   BYVAL GTuples PTR _                      ' GTuples     *tuples
 )                                          ' void

' ========================================================================================
'gpointer   g_tuples_index     (GTuples     *tuples,
'                               gint         index_,
'                               gint         field);
' ========================================================================================
DECLARE FUNCTION g_tuples_index CDECL LIB $GLIB_DLLNAME ALIAS "g_tuples_index" ( _
   BYVAL GTuples PTR _                      ' GTuples     *tuples
 , BYVAL LONG _                             ' gint         index_
 , BYVAL LONG _                             ' gint         field
 ) AS DWORD                                 ' gpointer

'G_END_DECLS

'#endif /* __G_REL_H__ */
#ENDIF   ' /* __GREL_INC__ */
