'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007
' * Soeren Sandmann (sandmann@daimi.au.dk)
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_SEQUENCE_H__
'#define __G_SEQUENCE_H__

#IF NOT %DEF(%GSEQUENCE_INC)
    %GSEQUENCE_INC = 1

#INCLUDE ONCE "gtypes.inc"

'G_BEGIN_DECLS

'typedef struct _GSequence      GSequence;
'typedef struct _GSequenceNode  GSequenceIter;

'typedef gint (* GSequenceIterCompareFunc) (GSequenceIter *a,
'                                           GSequenceIter *b,
'                                           gpointer       data);

'FUNCTION GSequenceIterCompareFunc (BYVAL a AS DWORD, BYVAL b AS DWORD, BYVAL pdata AS DWORD) AS LONG

'/* GSequence */
' ========================================================================================
'GSequence *    g_sequence_new                (GDestroyNotify            data_destroy);
' ========================================================================================
DECLARE FUNCTION g_sequence_new CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_new" ( _
   BYVAL DWORD _                            ' GDestroyNotify            data_destroy
 ) AS DWORD                                 ' GSequence*

' ========================================================================================
'void           g_sequence_free               (GSequence                *seq);
' ========================================================================================
DECLARE SUB g_sequence_free CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_free" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 )                                          ' void

' ========================================================================================
'gint           g_sequence_get_length         (GSequence                *seq);
' ========================================================================================
DECLARE FUNCTION g_sequence_get_length CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_get_length" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 ) AS DWORD                                 ' gint

' ========================================================================================
'void           g_sequence_foreach            (GSequence                *seq,
'                                              GFunc                     func,
'                                              gpointer                  user_data);
' ========================================================================================
DECLARE SUB g_sequence_foreach CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_foreach" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' GFunc                     func
 , BYVAL DWORD _                            ' gpointer                  user_data
 )                                          ' void

' ========================================================================================
'void           g_sequence_foreach_range      (GSequenceIter            *begin,
'                                              GSequenceIter            *end,
'                                              GFunc                     func,
'                                              gpointer                  user_data);
' ========================================================================================
DECLARE SUB g_sequence_foreach_range CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_foreach_range" ( _
   BYVAL DWORD _                            ' GSequenceIter            *begin
 , BYVAL DWORD _                            ' GSequenceIter            *end
 , BYVAL DWORD _                            ' GFunc                     func
 , BYVAL DWORD _                            ' gpointer                  user_data
 )                                          ' void

' ========================================================================================
'void           g_sequence_sort               (GSequence                *seq,
'                                              GCompareDataFunc          cmp_func,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE SUB g_sequence_sort CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_sort" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' GCompareDataFunc          cmp_func
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 )                                          ' void

' ========================================================================================
'void           g_sequence_sort_iter          (GSequence                *seq,
'                                              GSequenceIterCompareFunc  cmp_func,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE SUB g_sequence_sort_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_sort_iter" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' GSequenceIterCompareFunc  cmp_func
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 )                                          ' void


'/* Getting iters */

' ========================================================================================
'GSequenceIter *g_sequence_get_begin_iter     (GSequence                *seq);
' ========================================================================================
DECLARE FUNCTION g_sequence_get_begin_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_get_begin_iter" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_get_end_iter       (GSequence                *seq);
' ========================================================================================
DECLARE FUNCTION g_sequence_get_end_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_get_end_iter" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_get_iter_at_pos    (GSequence                *seq,
'                                              gint                      pos);
' ========================================================================================
DECLARE FUNCTION g_sequence_get_iter_at_pos CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_get_iter_at_pos" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL LONG _                             ' gint                      pos
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_append             (GSequence                *seq,
'                                              gpointer                  data);
' ========================================================================================
DECLARE FUNCTION g_sequence_append CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_append" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_prepend            (GSequence                *seq,
'                                              gpointer                  data);
' ========================================================================================
DECLARE FUNCTION g_sequence_prepend CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_prepend" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_insert_before      (GSequenceIter            *iter,
'                                              gpointer                  data);
' ========================================================================================
DECLARE FUNCTION g_sequence_prepend CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_prepend" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 , BYVAL DWORD _                            ' gpointer                  data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'void           g_sequence_move               (GSequenceIter            *src,
'                                              GSequenceIter            *dest);
' ========================================================================================
DECLARE SUB g_sequence_move CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_move" ( _
   BYVAL DWORD _                            ' GSequenceIter            *src
 , BYVAL DWORD _                            ' GSequenceIter            *dest
 )                                          ' void

' ========================================================================================
'void           g_sequence_swap               (GSequenceIter            *a,
'                                              GSequenceIter            *b);
' ========================================================================================
DECLARE SUB g_sequence_swap CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_swap" ( _
   BYVAL DWORD _                            ' GSequenceIter            *a
 , BYVAL DWORD _                            ' GSequenceIter            *b
 )                                          ' void

' ========================================================================================
'GSequenceIter *g_sequence_insert_sorted      (GSequence                *seq,
'                                              gpointer                  data,
'                                              GCompareDataFunc          cmp_func,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE FUNCTION g_sequence_insert_sorted CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_insert_sorted" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 , BYVAL DWORD _                            ' GCompareDataFunc          cmp_func
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_insert_sorted_iter (GSequence                *seq,
'                                              gpointer                  data,
'                                              GSequenceIterCompareFunc  iter_cmp,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE FUNCTION g_sequence_insert_sorted_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_insert_sorted_iter" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 , BYVAL DWORD _                            ' GSequenceIterCompareFunc  iter_cmp
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'void           g_sequence_sort_changed       (GSequenceIter            *iter,
'                                              GCompareDataFunc          cmp_func,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE SUB g_sequence_sort_changed CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_sort_changed" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 , BYVAL DWORD _                            ' GCompareDataFunc          cmp_func
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 )                                          ' void

' ========================================================================================
'void           g_sequence_sort_changed_iter  (GSequenceIter            *iter,
'                                              GSequenceIterCompareFunc  iter_cmp,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE SUB g_sequence_sort_changed_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_sort_changed_iter" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 , BYVAL DWORD _                            ' GSequenceIterCompareFunc  iter_cmp
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 )                                          ' void

' ========================================================================================
'void           g_sequence_remove             (GSequenceIter            *iter);
' ========================================================================================
DECLARE SUB g_sequence_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_remove" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 )                                          ' void

' ========================================================================================
'void           g_sequence_remove_range       (GSequenceIter            *begin,
'                                              GSequenceIter            *end);
' ========================================================================================
DECLARE SUB g_sequence_remove_range CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_remove_range" ( _
   BYVAL DWORD _                            ' GSequenceIter            *begin
 , BYVAL DWORD _                            ' GSequenceIter            *end
 )                                          ' void

' ========================================================================================
'void           g_sequence_move_range         (GSequenceIter            *dest,
'                                              GSequenceIter            *begin,
'                                              GSequenceIter            *end);
' ========================================================================================
DECLARE SUB g_sequence_move_range CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_move_range" ( _
   BYVAL DWORD _                            ' GSequenceIter            *dest
 , BYVAL DWORD _                            ' GSequenceIter            *begin
 , BYVAL DWORD _                            ' GSequenceIter            *end
 )                                          ' void

' ========================================================================================
'GSequenceIter *g_sequence_search             (GSequence                *seq,
'                                              gpointer                  data,
'                                              GCompareDataFunc          cmp_func,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE FUNCTION g_sequence_search CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_search" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 , BYVAL DWORD _                            ' GCompareDataFunc          cmp_func
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequenceIter *g_sequence_search_iter        (GSequence                *seq,
'                                              gpointer                  data,
'                                              GSequenceIterCompareFunc  iter_cmp,
'                                              gpointer                  cmp_data);
' ========================================================================================
DECLARE FUNCTION g_sequence_search_iter CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_search_iter" ( _
   BYVAL DWORD _                            ' GSequence                *seq
 , BYVAL DWORD _                            ' gpointer                  data
 , BYVAL DWORD _                            ' GSequenceIterCompareFunc  iter_cmp
 , BYVAL DWORD _                            ' gpointer                  cmp_data
 ) AS DWORD                                 ' GSequenceIter*


'/* Dereferencing */

' ========================================================================================
'gpointer       g_sequence_get                (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_get CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_get" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'void           g_sequence_set                (GSequenceIter            *iter,
'                                              gpointer                  data);
' ========================================================================================
DECLARE SUB g_sequence_set CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_set" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 , BYVAL DWORD _                            ' gpointer                  data
 )                                          ' void

'/* Operations on GSequenceIter * */

' ========================================================================================
'gboolean       g_sequence_iter_is_begin      (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_is_begin CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_is_begin" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean       g_sequence_iter_is_end        (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_is_end CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_is_end" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS LONG                                  ' gboolean

' ========================================================================================
'GSequenceIter *g_sequence_iter_next          (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_next CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_next" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS LONG                                  ' gboolean

' ========================================================================================
'GSequenceIter *g_sequence_iter_prev          (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_prev CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_prev" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gint           g_sequence_iter_get_position  (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_get_position CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_get_position" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS LONG                                  ' gint

' ========================================================================================
'GSequenceIter *g_sequence_iter_move          (GSequenceIter            *iter,
'                                              gint                      delta);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_move CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_move" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 , BYVAL LONG _                             ' gint                      delta
 ) AS DWORD                                 ' GSequenceIter*

' ========================================================================================
'GSequence *    g_sequence_iter_get_sequence  (GSequenceIter            *iter);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_get_sequence CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_get_sequence" ( _
   BYVAL DWORD _                            ' GSequenceIter            *iter
 ) AS DWORD                                 ' GSequence*


'/* Search */

' ========================================================================================
'gint           g_sequence_iter_compare       (GSequenceIter            *a,
'                                              GSequenceIter            *b);
' ========================================================================================
DECLARE FUNCTION g_sequence_iter_compare CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_iter_compare" ( _
   BYVAL DWORD _                            ' GSequenceIter            *a
 , BYVAL DWORD _                            ' GSequenceIter            *b
 ) AS LONG                                  ' gint

' ========================================================================================
'GSequenceIter *g_sequence_range_get_midpoint (GSequenceIter            *begin,
'                                              GSequenceIter            *end);
' ========================================================================================
DECLARE FUNCTION g_sequence_range_get_midpoint CDECL LIB $GLIB_DLLNAME ALIAS "g_sequence_range_get_midpoint" ( _
   BYVAL DWORD _                            ' GSequenceIter            *begin
 , BYVAL DWORD _                            ' GSequenceIter            *end
 ) AS DWORD                                 ' GSequenceIter*

'G_END_DECLS

'#endif /* __G_SEQUENCE_H__ */
#ENDIF   ' /* __GSEQUENCE_INC__ */
