'/* gshell.h - Shell-related utilities
' *
' *  Copyright 2000 Red Hat, Inc.
' *
' * GLib is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public License as
' * published by the Free Software Foundation; either version 2 of the
' * License, or (at your option) any later version.
' *
' * GLib is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with GLib; see the file COPYING.LIB.  If not, write
' * to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_SHELL_H__
'#define __G_SHELL_H__

#IF NOT %DEF(%GSHELL_INC)
    %GSHELL_INC = 1

#INCLUDE ONCE "gerror.inc"

'G_BEGIN_DECLS

'#define G_SHELL_ERROR g_shell_error_quark ()

'typedef enum
'{
'  /* mismatched or otherwise mangled quoting */
'  G_SHELL_ERROR_BAD_QUOTING,
'  /* string to be parsed was empty */
'  G_SHELL_ERROR_EMPTY_STRING,
'  G_SHELL_ERROR_FAILED
'} GShellError;

%G_SHELL_ERROR_BAD_QUOTING  = 0
%G_SHELL_ERROR_EMPTY_STRING = 1
%G_SHELL_ERROR_FAILED       = 2

' ========================================================================================
'GQuark g_shell_error_quark (void);
' ========================================================================================
DECLARE FUNCTION g_shell_error_quark CDECL LIB $GLIB_DLLNAME ALIAS "g_shell_error_quark" ( _
 ) AS DWORD                                 ' GQuark

' ========================================================================================
'gchar*   g_shell_quote      (const gchar   *unquoted_string);
' ========================================================================================
DECLARE FUNCTION g_shell_quote CDECL LIB $GLIB_DLLNAME ALIAS "g_shell_quote" ( _
   BYREF ASCIIZ _                           ' const gchar   *unquoted_string
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*   g_shell_unquote    (const gchar   *quoted_string,
'                             GError       **error);
' ========================================================================================
DECLARE FUNCTION g_shell_unquote CDECL LIB $GLIB_DLLNAME ALIAS "g_shell_unquote" ( _
   BYREF ASCIIZ _                           ' const gchar   *unquoted_string
 , BYREF DWORD _                            ' GError       **error
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gboolean g_shell_parse_argv (const gchar   *command_line,
'                             gint          *argcp,
'                             gchar       ***argvp,
'                             GError       **error);
' ========================================================================================
DECLARE FUNCTION g_shell_parse_argv CDECL LIB $GLIB_DLLNAME ALIAS "g_shell_parse_argv" ( _
   BYREF ASCIIZ _                           ' const gchar   *command_line
 , BYREF LONG _                             ' gint          *argcp
 , BYREF DWORD _                            ' gchar       ***argvp
 , BYREF DWORD _                            ' GError       **error
 ) AS LONG                                  ' gboolean

'G_END_DECLS

'#endif /* __G_SHELL_H__ */
#ENDIF   ' /* __GSHELL_INC__ */
