'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_SLIST_H__
'#define __G_SLIST_H__

#IF NOT %DEF(%GSLIST_INC)
    %GSLIST_INC = 1

#INCLUDE ONCE "gmem.inc"

'G_BEGIN_DECLS

'typedef struct _GSList GSList;

'struct _GSList
'{
'  gpointer data;
'  GSList *next;
'};

TYPE GSList
   data AS DWORD
   next AS GSList PTR
END TYPE

'/* Singly linked lists
' */

' ========================================================================================
'GSList*  g_slist_alloc                   (void) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_alloc CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_alloc" ( _
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'void     g_slist_free                    (GSList           *list);
' ========================================================================================
DECLARE SUB g_slist_free CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_free" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 )                                          ' void

' ========================================================================================
'void     g_slist_free_1                  (GSList           *list);
' ========================================================================================
DECLARE SUB g_slist_free_1 CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_free_1" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 )                                          ' void

' ========================================================================================
'#define    g_slist_free1               g_slist_free_1
' ========================================================================================
DECLARE SUB g_slist_free1 CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_free_1" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 )                                          ' void

' ========================================================================================
'GSList*  g_slist_append                  (GSList           *list,
'                                          gpointer          data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_append CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_append" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gpointer          data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_prepend                 (GSList           *list,
'                                          gpointer          data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_prepend CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_prepend" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gpointer          data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_insert                  (GSList           *list,
'                                          gpointer          data,
'                                          gint              position) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_insert CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_insert" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gpointer          data
 , BYVAL LONG _                             ' gint              position
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_insert_sorted           (GSList           *list,
'                                          gpointer          data,
'                                          GCompareFunc      func) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_insert_sorted CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_insert_sorted" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gpointer          data
 , BYVAL DWORD _                            ' GCompareFunc      func
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_insert_sorted_with_data (GSList           *list,
'                                          gpointer          data,
'                                          GCompareDataFunc  func,
'                                          gpointer          user_data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_insert_sorted_with_data CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_insert_sorted_with_data" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gpointer          data
 , BYVAL DWORD _                            ' GCompareDataFunc  func
 , BYVAL DWORD _                            ' gpointer          user_data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_insert_before           (GSList           *slist,
'                                          GSList           *sibling,
'                                          gpointer          data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_insert_before CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_insert_before" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL GSList PTR _                       ' GSList           *sibling
 , BYVAL DWORD _                            ' gpointer          data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_concat                  (GSList           *list1,
'                                          GSList           *list2) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_concat CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_concat" ( _
   BYVAL GSList PTR _                       ' GSList           *list1
 , BYVAL GSList PTR _                       ' GSList           *list2
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_remove                  (GSList           *list,
'                                          gconstpointer     data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_remove" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_remove_all              (GSList           *list,
'                                          gconstpointer     data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_remove_all CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_remove_all" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_remove_link             (GSList           *list,
'                                          GSList           *link_) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_remove_link CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_remove_link" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL GSList PTR _                       ' GSList           *link_
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_delete_link             (GSList           *list,
'                                          GSList           *link_) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_delete_link CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_delete_link" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL GSList PTR _                       ' GSList           *link_
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_reverse                 (GSList           *list) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_reverse CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_reverse" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_copy                    (GSList           *list) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_copy CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_copy" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_nth                     (GSList           *list,
'                                          guint             n);
' ========================================================================================
DECLARE FUNCTION g_slist_nth CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_nth" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_find                    (GSList           *list,
'                                          gconstpointer     data);
' ========================================================================================
DECLARE FUNCTION g_slist_find CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_find" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_find_custom             (GSList           *list,
'                                          gconstpointer     data,
'                                          GCompareFunc      func);
' ========================================================================================
DECLARE FUNCTION g_slist_find_custom CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_find_custom" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gconstpointer     data
 , BYVAL DWORD _                            ' GCompareFunc      func
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'gint     g_slist_position                (GSList           *list,
'                                          GSList           *llink);
' ========================================================================================
DECLARE FUNCTION g_slist_position CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_position" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL GSList PTR _                       ' GSList           *llink
 ) AS LONG                                  ' gint

' ========================================================================================
'gint     g_slist_index                   (GSList           *list,
'                                          gconstpointer     data);
' ========================================================================================
DECLARE FUNCTION g_slist_index CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_index" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' gconstpointer     data
 ) AS LONG                                  ' gint

' ========================================================================================
'GSList*  g_slist_last                    (GSList           *list);
' ========================================================================================
DECLARE FUNCTION g_slist_last CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_last" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'guint    g_slist_length                  (GSList           *list);
' ========================================================================================
DECLARE FUNCTION g_slist_length CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_length" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 ) AS DWORD                                 ' guint

' ========================================================================================
'void     g_slist_foreach                 (GSList           *list,
'                                          GFunc             func,
'                                          gpointer          user_data);
' ========================================================================================
DECLARE SUB g_slist_foreach CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_foreach" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' GFunc             func
 , BYVAL DWORD _                            ' gpointer          user_data
 )                                          ' void

' ========================================================================================
'GSList*  g_slist_sort                    (GSList           *list,
'                                          GCompareFunc      compare_func) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_sort CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_sort" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' GCompareFunc      compare_func
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'GSList*  g_slist_sort_with_data          (GSList           *list,
'                                          GCompareDataFunc  compare_func,
'                                          gpointer          user_data) G_GNUC_WARN_UNUSED_RESULT;
' ========================================================================================
DECLARE FUNCTION g_slist_sort_with_data CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_sort_with_data" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' GCompareFunc      compare_func
 , BYVAL DWORD _                            ' gpointer          user_data
 ) AS DWORD                                 ' GSList*

' ========================================================================================
'gpointer g_slist_nth_data                (GSList           *list,
'                                          guint             n);
' ========================================================================================
DECLARE FUNCTION g_slist_nth_data CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_nth_data" ( _
   BYVAL GSList PTR _                       ' GSList           *list
 , BYVAL DWORD _                            ' guint             n
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'#define  g_slist_next(slist)            ((slist) ? (((GSList *)(slist))->next) : NULL)
' ========================================================================================
MACRO g_slist_next(slist) = IIF&(slist, @slist.next, %NULL)

'#ifndef G_DISABLE_DEPRECATED
' ========================================================================================
'void     g_slist_push_allocator          (gpointer      dummy);
' ========================================================================================
'DECLARE SUB g_slist_push_allocator CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_push_allocator" ( _
'   BYVAL DWORD _                            ' gpointer      dummy
' )                                          ' void

' ========================================================================================
'void     g_slist_pop_allocator           (void);
' ========================================================================================
'DECLARE SUB g_slist_pop_allocator CDECL LIB $GLIB_DLLNAME ALIAS "g_slist_pop_allocator" ( _
' )                                          ' void
'#endif

'G_END_DECLS

'#endif /* __G_SLIST_H__ */
#ENDIF   ' /* __GSLIST_INC__ */
