'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_STRFUNCS_H__
'#define __G_STRFUNCS_H__

#IF NOT %DEF(%GSTRFUNCS_INC)
    %GSTRFUNCS_INC = 1

'#include <stdarg.h>
#INCLUDE ONCE "gtypes.inc"

'G_BEGIN_DECLS

'/* Functions like the ones in <ctype.h> that are not affected by locale. */
'typedef enum {
'  G_ASCII_ALNUM  = 1 << 0,
'  G_ASCII_ALPHA  = 1 << 1,
'  G_ASCII_CNTRL  = 1 << 2,
'  G_ASCII_DIGIT  = 1 << 3,
'  G_ASCII_GRAPH  = 1 << 4,
'  G_ASCII_LOWER  = 1 << 5,
'  G_ASCII_PRINT  = 1 << 6,
'  G_ASCII_PUNCT  = 1 << 7,
'  G_ASCII_SPACE  = 1 << 8,
'  G_ASCII_UPPER  = 1 << 9,
'  G_ASCII_XDIGIT = 1 << 10
'} GAsciiType;

%G_ASCII_ALNUM  = &H1??
%G_ASCII_ALPHA  = &H2??
%G_ASCII_CNTRL  = &H4??
%G_ASCII_DIGIT  = &H8??
%G_ASCII_GRAPH  = &H10??
%G_ASCII_LOWER  = &H20??
%G_ASCII_PRINT  = &H40??
%G_ASCII_PUNCT  = &H80??
%G_ASCII_SPACE  = &H100??
%G_ASCII_UPPER  = &H200??
%G_ASCII_XDIGIT = &H400??

'GLIB_VAR const guint16 * const g_ascii_table;

' Instead of a table lookup, we will use the equivalent functions from the C runtime

'#define g_ascii_isalnum(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_ALNUM) != 0)

FUNCTION g_ascii_isalnum (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_ALNUM) <> 0)
END FUNCTION

'#define g_ascii_isalpha(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_ALPHA) != 0)

FUNCTION g_ascii_isalpha (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_ALPHA) <> 0)
END FUNCTION

'#define g_ascii_iscntrl(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_CNTRL) != 0)

FUNCTION g_ascii_iscntrl (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_CNTRL) <> 0)
END FUNCTION

'#define g_ascii_isdigit(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_DIGIT) != 0)

FUNCTION g_ascii_isdigit (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_DIGIT) <> 0)
END FUNCTION

'#define g_ascii_isgraph(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_GRAPH) != 0)

FUNCTION g_ascii_isgraph (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_GRAPH) <> 0)
END FUNCTION

'#define g_ascii_islower(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_LOWER) != 0)

FUNCTION g_ascii_islower (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_LOWER) <> 0)
END FUNCTION

'#define g_ascii_isprint(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_PRINT) != 0)

FUNCTION g_ascii_isprint (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_PRINT) <> 0)
END FUNCTION

'#define g_ascii_ispunct(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_PUNCT) != 0)

FUNCTION g_ascii_ispunct (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_PUNCT) <> 0)
END FUNCTION

'#define g_ascii_isspace(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_SPACE) != 0)

FUNCTION g_ascii_isspace (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_SPACE) <> 0)
END FUNCTION

'#define g_ascii_isupper(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_UPPER) != 0)

FUNCTION g_ascii_isupper (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_UPPER) <> 0)
END FUNCTION

'#define g_ascii_isxdigit(c) \
'  ((g_ascii_table[(guchar) (c)] & G_ASCII_XDIGIT) != 0)

FUNCTION g_ascii_isxdigit (BYVAL c AS BYTE) AS LONG
   DIM ascii_table_data(0 TO 255) AS WORD
   ARRAY ASSIGN ascii_table_data() = _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H104, &H104, &H004, &H104, &H104, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H004, &H004, &H004, &H004, &H004, &H004, &H004, &H004, _
   &H140, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H459, &H459, &H459, &H459, &H459, &H459, &H459, &H459, _
   &H459, &H459, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H653, &H653, &H653, &H653, &H653, &H653, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H253, &H253, &H253, &H253, &H253, _
   &H253, &H253, &H253, &H0d0, &H0d0, &H0d0, &H0d0, &H0d0, _
   &H0d0, &H473, &H473, &H473, &H473, &H473, &H473, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H073, &H073, &H073, &H073, &H073, _
   &H073, &H073, &H073, &H0d0, &H0d0, &H0d0, &H0d0, &H004
   '  /* the upper 128 are all zeroes */
   FUNCTION = ((ascii_table_data(c) AND %G_ASCII_XDIGIT) <> 0)
END FUNCTION

' ========================================================================================
'gchar                 g_ascii_tolower  (gchar        c) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_ascii_tolower CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_tolower" ( _
   BYVAL BYTE _                             ' gchar        c
 ) AS BYTE                                  ' gchar

' ========================================================================================
'gchar                 g_ascii_toupper  (gchar        c) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_ascii_toupper CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_toupper" ( _
   BYVAL BYTE _                             ' gchar        c
 ) AS BYTE                                  ' gchar

' ========================================================================================
'gint                  g_ascii_digit_value  (gchar    c) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_ascii_digit_value CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_digit_value" ( _
   BYVAL BYTE _                             ' gchar        c
 ) AS LONG                                  ' gint

' ========================================================================================
'gint                  g_ascii_xdigit_value (gchar    c) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_ascii_xdigit_value CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_xdigit_value" ( _
   BYVAL BYTE _                             ' gchar        c
 ) AS LONG                                  ' gint

'/* String utility functions that modify a string argument or
' * return a constant string that must not be freed.
' */
'#define    G_STR_DELIMITERS   "_-|> <."
$G_STR_DELIMITERS = "_-|> <."

' ========================================================================================
'gchar*                 g_strdelimit     (gchar        *string,
'                                         const gchar  *delimiters,
'                                         gchar         new_delimiter);
' ========================================================================================
DECLARE FUNCTION g_strdelimit CDECL LIB $GLIB_DLLNAME ALIAS "g_strdelimit" ( _
   BYREF ASCIIZ _                           ' gchar        *string
 , BYREF ASCIIZ _                           ' const gchar  *delimiters
 , BYVAL BYTE _                             ' gchar         new_delimiter
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strcanon       (gchar        *string,
'                                         const gchar  *valid_chars,
'                                         gchar         substitutor);
' ========================================================================================
DECLARE FUNCTION g_strcanon CDECL LIB $GLIB_DLLNAME ALIAS "g_strcanon" ( _
   BYREF ASCIIZ _                           ' gchar        *string
 , BYREF ASCIIZ _                           ' const gchar  *valid_chars
 , BYVAL BYTE _                             ' gchar         substitutor
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar* g_strerror       (gint         errnum) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_strerror CDECL LIB $GLIB_DLLNAME ALIAS "g_strerror" ( _
   BYVAL LONG _                             ' gint         errnum
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar* g_strsignal      (gint         signum) G_GNUC_CONST;
' ========================================================================================
DECLARE FUNCTION g_strsignal CDECL LIB $GLIB_DLLNAME ALIAS "g_strsignal" ( _
   BYVAL LONG _                             ' gint         signum
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strreverse     (gchar        *string);
' ========================================================================================
DECLARE FUNCTION g_strreverse CDECL LIB $GLIB_DLLNAME ALIAS "g_strreverse" ( _
   BYREF ASCIIZ _                           ' gchar        *string
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gsize                 g_strlcpy          (gchar        *dest,
'                                          const gchar  *src,
'                                          gsize         dest_size);
' ========================================================================================
DECLARE FUNCTION g_strlcpy CDECL LIB $GLIB_DLLNAME ALIAS "g_strlcpy" ( _
   BYREF ASCIIZ _                           ' gchar        *dest
 , BYREF ASCIIZ _                           ' gchar        *src
 , BYVAL DWORD _                            ' gsize         dest_size
 ) AS DWORD                                 ' gsize

' ========================================================================================
'gsize                 g_strlcat        (gchar        *dest,
'                                        const gchar  *src,
'                                        gsize         dest_size);
' ========================================================================================
DECLARE FUNCTION g_strlcat CDECL LIB $GLIB_DLLNAME ALIAS "g_strlcat" ( _
   BYREF ASCIIZ _                           ' gchar        *dest
 , BYREF ASCIIZ _                           ' gchar        *src
 , BYVAL DWORD _                            ' gsize         dest_size
 ) AS DWORD                                 ' gsize

' ========================================================================================
'gchar *               g_strstr_len     (const gchar  *haystack,
'                                        gssize        haystack_len,
'                                        const gchar  *needle);
' ========================================================================================
DECLARE FUNCTION g_strstr_len CDECL LIB $GLIB_DLLNAME ALIAS "g_strstr_len" ( _
   BYREF ASCIIZ _                           ' const gchar  *haystack
 , BYVAL LONG _                             ' gssize        haystack_len
 , BYREF ASCIIZ _                           ' const gchar  *needle
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *               g_strrstr        (const gchar  *haystack,
'                                        const gchar  *needle);
' ========================================================================================
DECLARE FUNCTION g_strrstr CDECL LIB $GLIB_DLLNAME ALIAS "g_strrstr" ( _
   BYREF ASCIIZ _                           ' const gchar  *haystack
 , BYREF ASCIIZ _                           ' const gchar  *needle
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *               g_strrstr_len    (const gchar  *haystack,
'                                        gssize        haystack_len,
'                                        const gchar  *needle);
' ========================================================================================
DECLARE FUNCTION g_strrstr_len CDECL LIB $GLIB_DLLNAME ALIAS "g_strrstr_len" ( _
   BYREF ASCIIZ _                           ' const gchar  *haystack
 , BYVAL LONG _                             ' gssize        haystack_len
 , BYREF ASCIIZ _                           ' const gchar  *needle
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gboolean              g_str_has_suffix (const gchar  *str,
'                                        const gchar  *suffix);
' ========================================================================================
DECLARE FUNCTION g_str_has_suffix CDECL LIB $GLIB_DLLNAME ALIAS "g_str_has_suffix" ( _
   BYREF ASCIIZ _                           ' const gchar  *str
 , BYREF ASCIIZ _                           ' const gchar  *suffix
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean              g_str_has_prefix (const gchar  *str,
'                                        const gchar  *prefix);
' ========================================================================================
DECLARE FUNCTION g_str_has_prefix CDECL LIB $GLIB_DLLNAME ALIAS "g_str_has_prefix" ( _
   BYREF ASCIIZ _                           ' const gchar  *str
 , BYREF ASCIIZ _                           ' const gchar  *prefix
 ) AS LONG                                  ' gboolean

'/* String to/from double conversion functions */

' ========================================================================================
'gdouble                 g_strtod         (const gchar  *nptr,
'                                          gchar       **endptr);
' ========================================================================================
DECLARE FUNCTION g_strtod CDECL LIB $GLIB_DLLNAME ALIAS "g_strtod" ( _
   BYREF ASCIIZ _                           ' const gchar  *nptr
 , BYREF DWORD _                            ' gchar       **endptr
 ) AS DOUBLE                                ' gdouble

' ========================================================================================
'gdouble                 g_ascii_strtod   (const gchar  *nptr,
'                                          gchar       **endptr);
' ========================================================================================
DECLARE FUNCTION g_ascii_strtod CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strtod" ( _
   BYREF ASCIIZ _                           ' const gchar  *nptr
 , BYREF DWORD _                            ' gchar       **endptr
 ) AS DOUBLE                                ' gdouble

' ========================================================================================
'guint64            g_ascii_strtoull (const gchar *nptr,
'                                     gchar      **endptr,
'                                     guint        base);
' ========================================================================================
'DECLARE FUNCTION g_ascii_strtoull CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strtoull" ( _
'   BYREF ASCIIZ _                           ' const gchar  *nptr
' , BYREF DWORD _                            ' gchar       **endptr
' , BYVAL DWORD _                            ' guint         base
' ) AS QUAD                                  ' guint64

' ========================================================================================
'gint64            g_ascii_strtoll  (const gchar *nptr,
'                                    gchar      **endptr,
'                                    guint        base);
' ========================================================================================
'DECLARE FUNCTION g_ascii_strtoll CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strtoll" ( _
'   BYREF ASCIIZ _                           ' const gchar  *nptr
' , BYREF DWORD _                            ' gchar       **endptr
' , BYVAL DWORD _                            ' guint         base
' ) AS QUAD                                  ' gint64

'/* 29 bytes should enough for all possible values that
' * g_ascii_dtostr can produce.
' * Then add 10 for good measure */
'#define G_ASCII_DTOSTR_BUF_SIZE (29 + 10)
%G_ASCII_DTOSTR_BUF_SIZE = 29 + 10

' ========================================================================================
'gchar *               g_ascii_dtostr   (gchar        *buffer,
'                                        gint          buf_len,
'                                        gdouble       d);
' ========================================================================================
DECLARE FUNCTION g_ascii_dtostr CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_dtostr" ( _
   BYREF ASCIIZ _                           ' gchar        *buffer
 , BYVAL LONG _                             ' gint          buf_len
 , BYVAL DOUBLE _                           ' gdouble       d
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar *               g_ascii_formatd  (gchar        *buffer,
'                                        gint          buf_len,
'                                        const gchar  *format,
'                                        gdouble       d);
' ========================================================================================
DECLARE FUNCTION g_ascii_formatd CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_formatd" ( _
   BYREF ASCIIZ _                           ' gchar        *buffer
 , BYVAL LONG _                             ' gint          buf_len
 , BYREF ASCIIZ _                           ' const gchar  *format
 , BYVAL DOUBLE _                           ' gdouble       d
 ) AS DWORD                                 ' gchar*

'/* removes leading spaces */

' ========================================================================================
'gchar*                g_strchug        (gchar        *string);
' ========================================================================================
DECLARE FUNCTION g_strchug CDECL LIB $GLIB_DLLNAME ALIAS "g_strchug" ( _
   BYREF ASCIIZ _                           ' gchar        *string
 ) AS DWORD                                 ' gchar*

'/* removes trailing spaces */

' ========================================================================================
'gchar*                g_strchomp       (gchar        *string);
' ========================================================================================
DECLARE FUNCTION g_strchomp CDECL LIB $GLIB_DLLNAME ALIAS "g_strchomp" ( _
   BYREF ASCIIZ _                           ' gchar        *string
 ) AS DWORD                                 ' gchar*

'/* removes leading & trailing spaces */

' ========================================================================================
'#define g_strstrip( string )   g_strchomp (g_strchug (string))
' ========================================================================================
FUNCTION g_strstrip (BYREF szstr AS ASCIIZ) AS DWORD
   LOCAL psz AS ASCIIZ PTR
   psz = g_strchug(szstr)
   IF psz THEN FUNCTION = g_strchomp(BYVAL psz)
END FUNCTION

' ========================================================================================
'gint                  g_ascii_strcasecmp  (const gchar *s1,
'                                           const gchar *s2);
' ========================================================================================
DECLARE FUNCTION g_ascii_strcasecmp CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strcasecmp" ( _
   BYREF ASCIIZ _                           ' const gchar *s1
 , BYREF ASCIIZ _                           ' const gchar *s2
 ) AS LONG                                  ' gint

' ========================================================================================
'gint                  g_ascii_strncasecmp (const gchar *s1,
'                                           const gchar *s2,
'                                           gsize        n);
' ========================================================================================
DECLARE FUNCTION g_ascii_strncasecmp CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strncasecmp" ( _
   BYREF ASCIIZ _                           ' const gchar *s1
 , BYREF ASCIIZ _                           ' const gchar *s2
 , BYVAL DWORD _                            ' gsize        n
 ) AS LONG                                  ' gint

' ========================================================================================
'gchar*                g_ascii_strdown     (const gchar *str,
'                                           gssize       len) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_ascii_strdown CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strdown" ( _
   BYREF ANY _                              ' const gchar *str
 , BYVAL LONG _                             ' gssize       len
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                g_ascii_strup       (const gchar *str,
'                                           gssize       len) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_ascii_strup CDECL LIB $GLIB_DLLNAME ALIAS "g_ascii_strup" ( _
   BYREF ANY _                              ' const gchar *str
 , BYVAL LONG _                             ' gssize       len
 ) AS DWORD                                 ' gchar*

'#ifndef G_DISABLE_DEPRECATED

'/* The following four functions are deprecated and will be removed in
' * the next major release. They use the locale-specific tolower and
' * toupper, which is almost never the right thing.
' */

' ========================================================================================
'gint                 g_strcasecmp     (const gchar *s1,
'                                       const gchar *s2);
' ========================================================================================
'DECLARE FUNCTION g_strcasecmp CDECL LIB $GLIB_DLLNAME ALIAS "g_strcasecmp" ( _
'   BYREF ASCIIZ _                           ' const gchar *s1
' , BYREF ASCIIZ _                           ' const gchar *s2
' ) AS LONG                                  ' gint

' ========================================================================================
'gint                 g_strncasecmp    (const gchar *s1,
'                                       const gchar *s2,
'                                       guint        n);
' ========================================================================================
'DECLARE FUNCTION g_strncasecmp CDECL LIB $GLIB_DLLNAME ALIAS "g_strncasecmp" ( _
'   BYREF ASCIIZ _                           ' const gchar *s1
' , BYREF ASCIIZ _                           ' const gchar *s2
' , BYVAL DWORD _                            ' guint        n
' ) AS LONG                                  ' gint

' ========================================================================================
'gchar*                 g_strdown          (gchar        *string);
' ========================================================================================
'DECLARE FUNCTION g_strdown CDECL LIB $GLIB_DLLNAME ALIAS "g_strdown" ( _
'   BYREF ASCIIZ _                           ' gchar        *string
' ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strup          (gchar        *string);
' ========================================================================================
'DECLARE FUNCTION g_strup CDECL LIB $GLIB_DLLNAME ALIAS "g_strup" ( _
'   BYREF ASCIIZ _                           ' gchar        *string
' ) AS DWORD                                 ' gchar*

'#endif /* G_DISABLE_DEPRECATED */

'/* String utility functions that return a newly allocated string which
' * ought to be freed with g_free from the caller at some point.
' */

' ========================================================================================
'gchar*                 g_strdup          (const gchar *str) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strdup CDECL LIB $GLIB_DLLNAME ALIAS "g_strdup" ( _
   BYREF ASCIIZ _                           ' const gchar *str
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strdup_printf  (const gchar *format,
'                                         ...) G_GNUC_PRINTF (1, 2) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strdup_printf CDECL LIB $GLIB_DLLNAME ALIAS "g_strdup_printf" ( _
   BYREF ASCIIZ _                           ' const gchar *format
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strdup_vprintf (const gchar *format,
'                                         va_list      args) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strdup_vprintf CDECL LIB $GLIB_DLLNAME ALIAS "g_strdup_vprintf" ( _
   BYREF ASCIIZ _                           ' const gchar *format
 , BYREF ANY _                              ' va_list      args
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strndup          (const gchar *str,
'                                           gsize        n) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strndup CDECL LIB $GLIB_DLLNAME ALIAS "g_strndup" ( _
   BYREF ASCIIZ _                           ' const gchar *str
 , BYVAL DWORD _                            ' gsize        n
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strnfill       (gsize        length,
'                                         gchar        fill_char) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strnfill CDECL LIB $GLIB_DLLNAME ALIAS "g_strnfill" ( _
   BYVAL DWORD _                            ' gsize        length
 , BYVAL BYTE _                             ' gchar        fill_char
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                 g_strconcat      (const gchar *string1,
'                                         ...) G_GNUC_MALLOC G_GNUC_NULL_TERMINATED;
' ========================================================================================
DECLARE FUNCTION g_strconcat CDECL LIB $GLIB_DLLNAME ALIAS "g_strconcat" ( _
   BYREF ASCIIZ _                           ' const gchar *string1
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gchar*                g_strjoin          (const gchar  *separator,
'                                          ...) G_GNUC_MALLOC G_GNUC_NULL_TERMINATED;
' ========================================================================================
DECLARE FUNCTION g_strjoin CDECL LIB $GLIB_DLLNAME ALIAS "g_strjoin" ( _
   BYREF ASCIIZ _                           ' const gchar *separator
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 , OPTIONAL ANY _
 ) AS DWORD                                 ' gchar*

'/* Make a copy of a string interpreting C string -style escape
' * sequences. Inverse of g_strescape. The recognized sequences are \b
' * \f \n \r \t \\ \" and the octal format.
' */

' ========================================================================================
'gchar*                g_strcompress    (const gchar *source) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strcompress CDECL LIB $GLIB_DLLNAME ALIAS "g_strcompress" ( _
   BYREF ASCIIZ _                           ' const gchar *source
 ) AS DWORD                                 ' gchar*

'/* Copy a string escaping nonprintable characters like in C strings.
' * Inverse of g_strcompress. The exceptions parameter, if non-NULL, points
' * to a string containing characters that are not to be escaped.
' *
' * Deprecated API: gchar* g_strescape (const gchar *source);
' * Luckily this function wasn't used much, using NULL as second parameter
' * provides mostly identical semantics.
' */

' ========================================================================================
'gchar*                g_strescape      (const gchar *source,
'                                        const gchar *exceptions) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strescape CDECL LIB $GLIB_DLLNAME ALIAS "g_strescape" ( _
   BYREF ASCIIZ _                           ' const gchar *source
 , BYREF ASCIIZ _                           ' const gchar *exceptions
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'gpointer              g_memdup          (gconstpointer mem,
'                                         guint         byte_size) G_GNUC_MALLOC G_GNUC_ALLOC_SIZE(2);
' ========================================================================================
DECLARE FUNCTION g_memdup CDECL LIB $GLIB_DLLNAME ALIAS "g_memdup" ( _
   BYVAL DWORD _                            ' gconstpointer mem
 , BYVAL DWORD _                            ' guint         byte_size
 ) AS DWORD                                 ' gpointer

'/* NULL terminated string arrays.
' * g_strsplit(), g_strsplit_set() split up string into max_tokens tokens
' * at delim and return a newly allocated string array.
' * g_strjoinv() concatenates all of str_array's strings, sliding in an
' * optional separator, the returned string is newly allocated.
' * g_strfreev() frees the array itself and all of its strings.
' * g_strdupv() copies a NULL-terminated array of strings
' * g_strv_length() returns the length of a NULL-terminated array of strings
' */

' ========================================================================================
'gchar**                 g_strsplit       (const gchar  *string,
'                                          const gchar  *delimiter,
'                                          gint          max_tokens) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strsplit CDECL LIB $GLIB_DLLNAME ALIAS "g_strsplit" ( _
   BYREF ASCIIZ _                           ' const gchar  *string
 , BYREF ASCIIZ _                           ' const gchar  *delimiter
 , BYVAL LONG _                             ' gint          max_tokens
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gchar **         g_strsplit_set   (const gchar *string,
'                                   const gchar *delimiters,
'                                   gint         max_tokens) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strsplit_set CDECL LIB $GLIB_DLLNAME ALIAS "g_strsplit_set" ( _
   BYREF ASCIIZ _                           ' const gchar  *string
 , BYREF ASCIIZ _                           ' const gchar  *delimiters
 , BYVAL LONG _                             ' gint          max_tokens
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'gchar*                g_strjoinv       (const gchar  *separator,
'                                        gchar       **str_array) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strjoinv CDECL LIB $GLIB_DLLNAME ALIAS "g_strjoinv" ( _
   BYREF ASCIIZ _                           ' const gchar  *separator
 , BYVAL DWORD _                            ' gchar       **str_array
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'void                  g_strfreev       (gchar       **str_array);
' ========================================================================================
DECLARE SUB g_strfreev CDECL LIB $GLIB_DLLNAME ALIAS "g_strfreev" ( _
   BYVAL DWORD _                            ' gchar **str_array
 )                                          ' void

' ========================================================================================
'gchar**               g_strdupv        (gchar       **str_array) G_GNUC_MALLOC;
' ========================================================================================
DECLARE FUNCTION g_strdupv CDECL LIB $GLIB_DLLNAME ALIAS "g_strdupv" ( _
   BYVAL DWORD _                            ' gchar **str_array
 ) AS DWORD                                 ' gchar**

' ========================================================================================
'guint                 g_strv_length    (gchar       **str_array);
' ========================================================================================
DECLARE FUNCTION g_strv_length CDECL LIB $GLIB_DLLNAME ALIAS "g_strv_length" ( _
   BYVAL DWORD _                            ' gchar **str_array
 ) AS DWORD                                 ' guint

' ========================================================================================
'gchar*                g_stpcpy         (gchar        *dest,
'                                        const char   *src);
' ========================================================================================
DECLARE FUNCTION g_stpcpy CDECL LIB $GLIB_DLLNAME ALIAS "g_stpcpy" ( _
   BYREF ASCIIZ _                           ' gchar        *dest
 , BYREF ASCIIZ _                           ' const char   *src
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar *g_strip_context  (const gchar *msgid,
'                                        const gchar *msgval) G_GNUC_FORMAT(1);
' ========================================================================================
DECLARE FUNCTION g_strip_context CDECL LIB $GLIB_DLLNAME ALIAS "g_strip_context" ( _
   BYREF ASCIIZ _                           ' const gchar  *msgid
 , BYREF ASCIIZ _                           ' const char   *msgval
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar *g_dgettext       (const gchar *domain,
'                                        const gchar *msgid) G_GNUC_FORMAT(2);
' ========================================================================================
DECLARE FUNCTION g_dgettext CDECL LIB $GLIB_DLLNAME ALIAS "g_dgettext" ( _
   BYREF ASCIIZ _                           ' const gchar  *domain
 , BYREF ASCIIZ _                           ' const char   *msgid
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar *g_dngettext      (const gchar *domain,
'                                        const gchar *msgid,
'                                        const gchar *msgid_plural,
'                                        gulong       n) G_GNUC_FORMAT(3);
' ========================================================================================
DECLARE FUNCTION g_dngettext CDECL LIB $GLIB_DLLNAME ALIAS "g_dngettext" ( _
   BYREF ASCIIZ _                           ' const gchar  *domain
 , BYREF ASCIIZ _                           ' const char   *msgid
 , BYREF ASCIIZ _                           ' const char   *msgid_plural
 , BYVAL DWORD _                            ' gulong       n
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar *g_dpgettext      (const gchar *domain,
'                                        const gchar *msgctxtid,
'                                        gsize        msgidoffset) G_GNUC_FORMAT(2);
' ========================================================================================
DECLARE FUNCTION g_dpgettext CDECL LIB $GLIB_DLLNAME ALIAS "g_dpgettext" ( _
   BYREF ASCIIZ _                           ' const gchar  *domain
 , BYREF ASCIIZ _                           ' const char   *msgctxtid
 , BYVAL DWORD _                            ' gsize         msgidoffset
 ) AS DWORD                                 ' gchar*

' ========================================================================================
'G_CONST_RETURN gchar *g_dpgettext2     (const gchar *domain,
'                                        const gchar *context,
'                                        const gchar *msgid) G_GNUC_FORMAT(3);
' ========================================================================================
DECLARE FUNCTION g_dpgettext2 CDECL LIB $GLIB_DLLNAME ALIAS "g_dpgettext2" ( _
   BYREF ASCIIZ _                           ' const gchar  *domain
 , BYREF ASCIIZ _                           ' const char   *context
 , BYREF ASCIIZ _                           ' const char   *msgid
 ) AS DWORD                                 ' gchar*

'G_END_DECLS

'#endif /* __G_STRFUNCS_H__ */
#ENDIF   ' /* __GSTRFUNCS_INC__ */
