'/* GLIB - Library of useful routines for C programming
' * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
' *
' * This library is free software; you can redistribute it and/or
' * modify it under the terms of the GNU Lesser General Public
' * License as published by the Free Software Foundation; either
' * version 2 of the License, or (at your option) any later version.
' *
' * This library is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the GNU
' * Lesser General Public License for more details.
' *
' * You should have received a copy of the GNU Lesser General Public
' * License along with this library; if not, write to the
' * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
' * Boston, MA 02111-1307, USA.
' */

'/*
' * Modified by the GLib Team and others 1997-2000.  See the AUTHORS
' * file for a list of people on the GLib Team.  See the ChangeLog
' * files for a list of changes.  These files are distributed with
' * GLib at ftp://ftp.gtk.org/pub/gtk/.
' */

'#if defined(G_DISABLE_SINGLE_INCLUDES) && !defined (__GLIB_H_INSIDE__) && !defined (GLIB_COMPILATION)
'#error "Only <glib.h> can be included directly."
'#endif

'#ifndef __G_TREE_H__
'#define __G_TREE_H__

#IF NOT %DEF(%GTREE_INC)
    %GTREE_INC = 1

#INCLUDE ONCE "gnode.inc"

'G_BEGIN_DECLS

'typedef struct _GTree  GTree;

'typedef gboolean (*GTraverseFunc) (gpointer  key,
'                                   gpointer  value,
'                                   gpointer  data);

'FUNCTION GTraverseFunc (BYVAL pkey AS DWORD, BYVAL value AS DWORD, BYVAL pdata AS DWORD) AS LONG

'/* Balanced binary trees
' */

' ========================================================================================
'GTree*   g_tree_new             (GCompareFunc      key_compare_func);
' ========================================================================================
DECLARE FUNCTION g_tree_new CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_new" ( _
   BYVAL DWORD _                            ' GCompareFunc      key_compare_func
 ) AS DWORD                                 ' GTree*

' ========================================================================================
'GTree*   g_tree_new_with_data   (GCompareDataFunc  key_compare_func,
'                                 gpointer          key_compare_data);
' ========================================================================================
DECLARE FUNCTION g_tree_new_with_data CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_new_with_data" ( _
   BYVAL DWORD _                            ' GCompareFunc      key_compare_func
 , BYVAL DWORD _                            ' gpointer          key_compare_data
 ) AS DWORD                                 ' GTree*

' ========================================================================================
'GTree*   g_tree_new_full        (GCompareDataFunc  key_compare_func,
'                                 gpointer          key_compare_data,
'                                 GDestroyNotify    key_destroy_func,
'                                 GDestroyNotify    value_destroy_func);
' ========================================================================================
DECLARE FUNCTION g_tree_new_full CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_new_full" ( _
   BYVAL DWORD _                            ' GCompareFunc      key_compare_func
 , BYVAL DWORD _                            ' gpointer          key_compare_data
 , BYVAL DWORD _                            ' GDestroyNotify    key_destroy_func
 , BYVAL DWORD _                            ' GDestroyNotify    value_destroy_func
 ) AS DWORD                                 ' GTree*

' ========================================================================================
'void     g_tree_destroy         (GTree            *tree);
' ========================================================================================
DECLARE SUB g_tree_destroy CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_destroy" ( _
   BYVAL DWORD _                            ' GTree            *tree
 )                                          ' void

' ========================================================================================
'void     g_tree_insert          (GTree            *tree,
'                                 gpointer          key,
'                                 gpointer          value);
' ========================================================================================
DECLARE SUB g_tree_insert CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_insert" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gpointer          key
 , BYVAL DWORD _                            ' gpointer          value
 )                                          ' void

' ========================================================================================
'void     g_tree_replace         (GTree            *tree,
'                                 gpointer          key,
'                                 gpointer          value);
' ========================================================================================
DECLARE SUB g_tree_replace CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_replace" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gpointer          key
 , BYVAL DWORD _                            ' gpointer          value
 )                                          ' void

' ========================================================================================
'gboolean g_tree_remove          (GTree            *tree,
'                                 gconstpointer     key);
' ========================================================================================
DECLARE FUNCTION g_tree_remove CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_remove" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gconstpointer     key
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gboolean g_tree_steal           (GTree            *tree,
'                                 gconstpointer     key);
' ========================================================================================
DECLARE FUNCTION g_tree_steal CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_steal" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gconstpointer     key
 ) AS LONG                                  ' gboolean

' ========================================================================================
'gpointer g_tree_lookup          (GTree            *tree,
'                                 gconstpointer     key);
' ========================================================================================
DECLARE FUNCTION g_tree_lookup CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_lookup" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gconstpointer     key
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gboolean g_tree_lookup_extended (GTree            *tree,
'                                 gconstpointer     lookup_key,
'                                 gpointer         *orig_key,
'                                 gpointer         *value);
' ========================================================================================
DECLARE FUNCTION g_tree_lookup_extended CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_lookup_extended" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' gconstpointer     lookup_key
 , BYREF DWORD _                            ' gpointer         *orig_key
 , BYREF DWORD _                            ' gpointer         *value
 ) AS LONG                                  ' gboolean

' ========================================================================================
'void     g_tree_foreach         (GTree            *tree,
'                                 GTraverseFunc     func,
'                                 gpointer          user_data);
' ========================================================================================
DECLARE SUB g_tree_foreach CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_foreach" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' GTraverseFunc     func
 , BYVAL DWORD _                            ' gpointer          user_data
 )                                          ' void

'#ifndef G_DISABLE_DEPRECATED
'void     g_tree_traverse        (GTree            *tree,
'                                 GTraverseFunc     traverse_func,
'                                 GTraverseType     traverse_type,
'                                 gpointer          user_data);
'DECLARE SUB g_tree_traverse CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_traverse" ( _
'   BYVAL DWORD _                        ' GTree            *tree
' , BYVAL DWORD _                            ' GTraverseFunc     traverse_func
' , BYVAL LONG _                             ' GTraverseType     traverse_type
' , BYVAL DWORD _                            ' gpointer          user_data
' )                                          ' void
'#endif /* G_DISABLE_DEPRECATED */

' ========================================================================================
'gpointer g_tree_search          (GTree            *tree,
'                                 GCompareFunc      search_func,
'                                 gconstpointer     user_data);
' ========================================================================================
DECLARE FUNCTION g_tree_search CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_search" ( _
   BYVAL DWORD _                            ' GTree            *tree
 , BYVAL DWORD _                            ' GCompareFunc      search_func
 , BYVAL DWORD _                            ' gconstpointer     user_data
 ) AS DWORD                                 ' gpointer

' ========================================================================================
'gint     g_tree_height          (GTree            *tree);
' ========================================================================================
DECLARE FUNCTION g_tree_height CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_height" ( _
   BYVAL DWORD _                            ' GTree            *tree
 ) AS LONG                                  ' gint

' ========================================================================================
'gint     g_tree_nnodes          (GTree            *tree);
' ========================================================================================
DECLARE FUNCTION g_tree_nnodes CDECL LIB $GLIB_DLLNAME ALIAS "g_tree_nnodes" ( _
   BYVAL DWORD _                            ' GTree            *tree
 ) AS LONG                                  ' gint

'G_END_DECLS

'#endif /* __G_TREE_H__ */
#ENDIF   ' /* __GTREE_INC__ */
